<?php

// --------------------------------------------------------------------------------
// PhpConcept Library - Zip Module 2.1
// --------------------------------------------------------------------------------
// License GNU/LGPL - Vincent Blavet - December 2003
// http://www.phpconcept.net
// --------------------------------------------------------------------------------

if(!defined('_VALID')){header('Status: 404 Not Found');die;}

    define( 'PCLZIP_READ_BLOCK_SIZE', 2048 );
  define( 'PCLZIP_SEPARATOR', ',' );
  define( 'PCLZIP_ERROR_EXTERNAL', 0 );
  define( 'PCLZIP_TEMPORARY_DIR', '' );
  
    // ----- Options values
  define( 'PCLZIP_OPT_PATH', 77001 );
  define( 'PCLZIP_OPT_ADD_PATH', 77002 );
  define( 'PCLZIP_OPT_REMOVE_PATH', 77003 );
  define( 'PCLZIP_OPT_REMOVE_ALL_PATH', 77004 );
  define( 'PCLZIP_OPT_SET_CHMOD', 77005 );
  define( 'PCLZIP_OPT_EXTRACT_AS_STRING', 77006 );
  define( 'PCLZIP_OPT_NO_COMPRESSION', 77007 );
  define( 'PCLZIP_OPT_BY_NAME', 77008 );
  define( 'PCLZIP_OPT_BY_INDEX', 77009 );
  define( 'PCLZIP_OPT_BY_EREG', 77010 );
  define( 'PCLZIP_OPT_BY_PREG', 77011 );
  define( 'PCLZIP_OPT_COMMENT', 77012 );
  define( 'PCLZIP_OPT_ADD_COMMENT', 77013 );
  define( 'PCLZIP_OPT_PREPEND_COMMENT', 77014 );
  define( 'PCLZIP_OPT_EXTRACT_IN_OUTPUT', 77015 );


    $g_pclzip_version = "2.1";

    define( 'PCLZIP_CB_PRE_EXTRACT', 78001 );
  define( 'PCLZIP_CB_POST_EXTRACT', 78002 );
  define( 'PCLZIP_CB_PRE_ADD', 78003 );
  define( 'PCLZIP_CB_POST_ADD', 78004 );

  class PclZip
  {
        var $zipname = '';

        var $zip_fd = 0;

        var $error_code = 1;
    var $error_string = '';
	
    function PclZip($p_zipname)
   {
    
        if (!function_exists('gzopen'))
    {
            die('Abort '.basename(__FILE__).' : Missing zlib extensions');
    }

        $this->zipname = $p_zipname;
    $this->zip_fd = 0;

            return;
  }
  
  	function extract($dir)
	{
	$p_list=array();
	$this->privExtractByRule($p_list,$dir,"","",$v_options);
	}
	
   function privOpenFd($p_mode)
  {
    $v_result=1;
    if ($this->zip_fd != 0)
    {
	echo "already open";
	 }
    if (($this->zip_fd = @fopen($this->zipname, $p_mode)) == 0)
    {
	echo "error opening";	
    }
    return $v_result;
  }
  
  function privCloseFd()
  {
    $v_result=1;
    if ($this->zip_fd != 0)
      @fclose($this->zip_fd);
    $this->zip_fd = 0;
    return $v_result;
  }
  
  function privErrorLog($err_id,$error_msg)
  {
  echo $error_msg;
  }


  function privConvertHeader2FileInfo($p_header, &$p_info)
  {
        $v_result=1;

        $p_info['filename'] = $p_header['filename'];
    $p_info['stored_filename'] = $p_header['stored_filename'];
    $p_info['size'] = $p_header['size'];
    $p_info['compressed_size'] = $p_header['compressed_size'];
    $p_info['mtime'] = $p_header['mtime'];
    $p_info['comment'] = $p_header['comment'];
    $p_info['folder'] = (($p_header['external']&0x00000010)==0x00000010);
    $p_info['index'] = $p_header['index'];
    $p_info['status'] = $p_header['status'];

            return $v_result;
  }
  
                                  function privExtractByRule(&$p_file_list, $p_path, $p_remove_path, $p_remove_all_path, &$p_options)
  {
        $v_result=1;

        if (($p_path == "") || ((substr($p_path, 0, 1) != "/") && (substr($p_path, 0, 3) != "../") && (substr($p_path,1,2)!=":/")))
      $p_path = "./".$p_path;

        if (($p_path != "./") && ($p_path != "/"))
    {
            while (substr($p_path, -1) == "/")
      {
                $p_path = substr($p_path, 0, strlen($p_path)-1);
              }
    }

        if (($p_remove_path != "") && (substr($p_remove_path, -1) != '/'))
    {
      $p_remove_path .= '/';
    }
    $p_remove_path_size = strlen($p_remove_path);

            if (($v_result = $this->privOpenFd('rb')) != 1)
    {
            return $v_result;
    }

        $v_central_dir = array();
    if (($v_result = $this->privReadEndCentralDir($v_central_dir)) != 1)
    {
            $this->privCloseFd();

            return $v_result;
    }

        $v_pos_entry = $v_central_dir['offset'];

        $j_start = 0;
    for ($i=0, $v_nb_extracted=0; $i<$v_central_dir['entries']; $i++)
    {
      
                  @rewind($this->zip_fd);
            if (@fseek($this->zip_fd, $v_pos_entry))
      {
                $this->privCloseFd();

                PclZip::privErrorLog(PCLZIP_ERR_INVALID_ARCHIVE_ZIP, 'Invalid archive size');

                        return PclZip::errorCode();
      }
      
            $v_header = array();
      if (($v_result = $this->privReadCentralFileHeader($v_header)) != 1)
      {
                $this->privCloseFd();

                return $v_result;
      }

            $v_header['index'] = $i;

            $v_pos_entry = ftell($this->zip_fd);

            $v_extract = false;

            if (   (isset($p_options[PCLZIP_OPT_BY_NAME]))
          && ($p_options[PCLZIP_OPT_BY_NAME] != 0)) {
          
                    for ($j=0; ($j<sizeof($p_options[PCLZIP_OPT_BY_NAME])) && (!$v_extract); $j++) {
              
                            if (substr($p_options[PCLZIP_OPT_BY_NAME][$j], -1) == "/") {
                  
                                    if (   (strlen($v_header['stored_filename']) > strlen($p_options[PCLZIP_OPT_BY_NAME][$j]))
                      && (substr($v_header['stored_filename'], 0, strlen($p_options[PCLZIP_OPT_BY_NAME][$j])) == $p_options[PCLZIP_OPT_BY_NAME][$j])) {
                                            $v_extract = true;
                  }
              }
                            elseif ($v_header['stored_filename'] == $p_options[PCLZIP_OPT_BY_NAME][$j]) {
                                    $v_extract = true;
              }
          }
      }

            else if (   (isset($p_options[PCLZIP_OPT_BY_EREG]))
               && ($p_options[PCLZIP_OPT_BY_EREG] != "")) {
          
          if (ereg($p_options[PCLZIP_OPT_BY_EREG], $v_header['stored_filename'])) {
                            $v_extract = true;
          }
      }

            else if (   (isset($p_options[PCLZIP_OPT_BY_PREG]))
               && ($p_options[PCLZIP_OPT_BY_PREG] != "")) {
          
          if (preg_match($p_options[PCLZIP_OPT_BY_PREG], $v_header['stored_filename'])) {
                            $v_extract = true;
          }
      }

            else if (   (isset($p_options[PCLZIP_OPT_BY_INDEX]))
               && ($p_options[PCLZIP_OPT_BY_INDEX] != 0)) {
                    
                    for ($j=$j_start; ($j<sizeof($p_options[PCLZIP_OPT_BY_INDEX])) && (!$v_extract); $j++) {
              
              if (($i>=$p_options[PCLZIP_OPT_BY_INDEX][$j]['start']) && ($i<=$p_options[PCLZIP_OPT_BY_INDEX][$j]['end'])) {
                                    $v_extract = true;
              }
              if ($i>=$p_options[PCLZIP_OPT_BY_INDEX][$j]['end']) {
                                    $j_start = $j+1;
              }

              if ($p_options[PCLZIP_OPT_BY_INDEX][$j]['start']>$i) {
                                    break;
              }
          }
      }

            else {
                    $v_extract = true;
      }
      

            if ($v_extract)
      {
        
                        @rewind($this->zip_fd);
                if (@fseek($this->zip_fd, $v_header['offset']))
        {
                    $this->privCloseFd();

                    PclZip::privErrorLog(PCLZIP_ERR_INVALID_ARCHIVE_ZIP, 'Invalid archive size');

                              return PclZip::errorCode();
        }
        
                if ($p_options[PCLZIP_OPT_EXTRACT_AS_STRING]) {

                    $v_result1 = $this->privExtractFileAsString($v_header, $v_string);
          if ($v_result1 < 1) {
            $this->privCloseFd();
                        return $v_result1;
          }

                    if (($v_result = $this->privConvertHeader2FileInfo($v_header, $p_file_list[$v_nb_extracted])) != 1)
          {
                        $this->privCloseFd();

                        return $v_result;
          }

                    $p_file_list[$v_nb_extracted]['content'] = $v_string;

                    $v_nb_extracted++;
          
                    if ($v_result1 == 2) {
          	break;
          }
        }
                elseif (   (isset($p_options[PCLZIP_OPT_EXTRACT_IN_OUTPUT]))
		        && ($p_options[PCLZIP_OPT_EXTRACT_IN_OUTPUT])) {
                    $v_result1 = $this->privExtractFileInOutput($v_header, $p_options);
          if ($v_result1 < 1) {
            $this->privCloseFd();
                        return $v_result1;
          }

                    if (($v_result = $this->privConvertHeader2FileInfo($v_header, $p_file_list[$v_nb_extracted++])) != 1) {
            $this->privCloseFd();
                        return $v_result;
          }

                    if ($v_result1 == 2) {
          	break;
          }
        }
                else {
                    $v_result1 = $this->privExtractFile($v_header,
		                                      $p_path, $p_remove_path,
											  $p_remove_all_path,
											  $p_options);
          if ($v_result1 < 1) {
            $this->privCloseFd();
                        return $v_result1;
          }

                    if (($v_result = $this->privConvertHeader2FileInfo($v_header, $p_file_list[$v_nb_extracted++])) != 1)
          {
                        $this->privCloseFd();

                        return $v_result;
          }

                    if ($v_result1 == 2) {
          	break;
          }
        }
      }
    }

        $this->privCloseFd();

            return $v_result;
  }
  
              function privExtractFile(&$p_entry, $p_path, $p_remove_path, $p_remove_all_path, &$p_options)
  {
        $v_result=1;

        if (($v_result = $this->privReadFileHeader($v_header)) != 1)
    {
                  return $v_result;
    }

    
        
        if ($p_remove_all_path == true) {
                $p_entry['filename'] = basename($p_entry['filename']);
    }

        else if ($p_remove_path != "")
    {
            if (PclZipUtilPathInclusion($p_remove_path, $p_entry['filename']) == 2)
      {
        
                $p_entry['status'] = "filtered";

                        return $v_result;
      }

      $p_remove_path_size = strlen($p_remove_path);
      if (substr($p_entry['filename'], 0, $p_remove_path_size) == $p_remove_path)
      {
        
                $p_entry['filename'] = substr($p_entry['filename'], $p_remove_path_size);

              }
    }

        if ($p_path != '')
    {
      $p_entry['filename'] = $p_path."/".$p_entry['filename'];
    }

        if (isset($p_options[PCLZIP_CB_PRE_EXTRACT])) {
      
            $v_local_header = array();
      $this->privConvertHeader2FileInfo($p_entry, $v_local_header);

                        eval('$v_result = '.$p_options[PCLZIP_CB_PRE_EXTRACT].'(PCLZIP_CB_PRE_EXTRACT, $v_local_header);');
      if ($v_result == 0) {
                $p_entry['status'] = "skipped";
        $v_result = 1;
      }
      
            if ($v_result == 2) {
                        $p_entry['status'] = "aborted";
      	$v_result = PCLZIP_ERR_USER_ABORTED;
      }

                  $p_entry['filename'] = $v_local_header['filename'];
          }

        
        if ($p_entry['status'] == 'ok') {

        if (file_exists($p_entry['filename']))
    {
      
            if (is_dir($p_entry['filename']))
      {
        
                $p_entry['status'] = "already_a_directory";

                              }
            else if (!is_writeable($p_entry['filename']))
      {
        
                $p_entry['status'] = "write_protected";

                              }

            else if (filemtime($p_entry['filename']) > $p_entry['mtime'])
      {
        
                $p_entry['status'] = "newer_exist";

                              }
    }

        else {
      if ((($p_entry['external']&0x00000010)==0x00000010) || (substr($p_entry['filename'], -1) == '/'))
        $v_dir_to_check = $p_entry['filename'];
      else if (!strstr($p_entry['filename'], "/"))
        $v_dir_to_check = "";
      else
        $v_dir_to_check = dirname($p_entry['filename']);

      if (($v_result = $this->privDirCheck($v_dir_to_check, (($p_entry['external']&0x00000010)==0x00000010))) != 1) {
        
                $p_entry['status'] = "path_creation_fail";

                                $v_result = 1;
      }
    }
    }

        if ($p_entry['status'] == 'ok') {

            if (!(($p_entry['external']&0x00000010)==0x00000010))
      {

                if ($p_entry['compressed_size'] == $p_entry['size'])
        {
          
                    if (($v_dest_file = @fopen($p_entry['filename'], 'wb')) == 0)
          {
            
                        $p_entry['status'] = "write_error";

                                    return $v_result;
          }

          
                    $v_size = $p_entry['compressed_size'];
          while ($v_size != 0)
          {
            $v_read_size = ($v_size < PCLZIP_READ_BLOCK_SIZE ? $v_size : PCLZIP_READ_BLOCK_SIZE);
                        $v_buffer = fread($this->zip_fd, $v_read_size);
            $v_binary_data = pack('a'.$v_read_size, $v_buffer);
            @fwrite($v_dest_file, $v_binary_data, $v_read_size);
            $v_size -= $v_read_size;
          }

                    fclose($v_dest_file);

                    touch($p_entry['filename'], $p_entry['mtime']);
        }
        else
        {
                    
                    if (($v_dest_file = @fopen($p_entry['filename'], 'wb')) == 0) {
            
                        $p_entry['status'] = "write_error";

                        return $v_result;
          }

          
                    $v_buffer = @fread($this->zip_fd, $p_entry['compressed_size']);

                    $v_file_content = gzinflate($v_buffer);
          unset($v_buffer);

                    @fwrite($v_dest_file, $v_file_content, $p_entry['size']);
          unset($v_file_content);

                    @fclose($v_dest_file);

                    touch($p_entry['filename'], $p_entry['mtime']);
        }

                if (isset($p_options[PCLZIP_OPT_SET_CHMOD])) {
          
                    chmod($p_entry['filename'], $p_options[PCLZIP_OPT_SET_CHMOD]);
        }

              }
    }

		if ($p_entry['status'] == "aborted") {
      $p_entry['status'] = "skipped";
	}
	
        elseif (isset($p_options[PCLZIP_CB_POST_EXTRACT])) {
      
            $v_local_header = array();
      $this->privConvertHeader2FileInfo($p_entry, $v_local_header);

                        eval('$v_result = '.$p_options[PCLZIP_CB_POST_EXTRACT].'(PCLZIP_CB_POST_EXTRACT, $v_local_header);');

            if ($v_result == 2) {
              	$v_result = PCLZIP_ERR_USER_ABORTED;
      }
    }

            return $v_result;
  }
  
              function privExtractFileInOutput(&$p_entry, &$p_options)
  {
        $v_result=1;

        if (($v_result = $this->privReadFileHeader($v_header)) != 1) {
            return $v_result;
    }

    
        
        if (isset($p_options[PCLZIP_CB_PRE_EXTRACT])) {
      
            $v_local_header = array();
      $this->privConvertHeader2FileInfo($p_entry, $v_local_header);

                        eval('$v_result = '.$p_options[PCLZIP_CB_PRE_EXTRACT].'(PCLZIP_CB_PRE_EXTRACT, $v_local_header);');
      if ($v_result == 0) {
                $p_entry['status'] = "skipped";
        $v_result = 1;
      }

            if ($v_result == 2) {
                        $p_entry['status'] = "aborted";
      	$v_result = PCLZIP_ERR_USER_ABORTED;
      }

                  $p_entry['filename'] = $v_local_header['filename'];
          }

        
        if ($p_entry['status'] == 'ok') {

            if (!(($p_entry['external']&0x00000010)==0x00000010)) {
                if ($p_entry['compressed_size'] == $p_entry['size']) {
                    
                    $v_buffer = @fread($this->zip_fd, $p_entry['compressed_size']);

                    echo $v_buffer;
          unset($v_buffer);
        }
        else {
                    
                    $v_buffer = @fread($this->zip_fd, $p_entry['compressed_size']);
          
                    $v_file_content = gzinflate($v_buffer);
          unset($v_buffer);

                    echo $v_file_content;
          unset($v_file_content);
        }
              }
    }

		if ($p_entry['status'] == "aborted") {
      $p_entry['status'] = "skipped";
	}

        elseif (isset($p_options[PCLZIP_CB_POST_EXTRACT])) {
      
            $v_local_header = array();
      $this->privConvertHeader2FileInfo($p_entry, $v_local_header);

                        eval('$v_result = '.$p_options[PCLZIP_CB_POST_EXTRACT].'(PCLZIP_CB_POST_EXTRACT, $v_local_header);');

            if ($v_result == 2) {
              	$v_result = PCLZIP_ERR_USER_ABORTED;
      }
    }

        return $v_result;
  }
  
              function privExtractFileAsString(&$p_entry, &$p_string)
  {
        $v_result=1;

        $v_header = array();
    if (($v_result = $this->privReadFileHeader($v_header)) != 1)
    {
                  return $v_result;
    }

    
        
        
        if (!(($p_entry['external']&0x00000010)==0x00000010))
    {
            if ($p_entry['compressed_size'] == $p_entry['size'])
      {
                        
                $p_string = fread($this->zip_fd, $p_entry['compressed_size']);
      }
      else
      {
                
                $v_data = fread($this->zip_fd, $p_entry['compressed_size']);
        
                $p_string = gzinflate($v_data);
      }

                }
    else {
            }

            return $v_result;
  }
  
              function privReadFileHeader(&$p_header)
  {
        $v_result=1;

        $v_binary_data = @fread($this->zip_fd, 4);
        $v_data = unpack('Vid', $v_binary_data);
    
        if ($v_data['id'] != 0x04034b50)
    {
      
            PclZip::privErrorLog(PCLZIP_ERR_BAD_FORMAT, 'Invalid archive structure');

                  return PclZip::errorCode();
    }

        $v_binary_data = fread($this->zip_fd, 26);

        if (strlen($v_binary_data) != 26)
    {
      $p_header['filename'] = "";
      $p_header['status'] = "invalid_header";
      
            PclZip::privErrorLog(PCLZIP_ERR_BAD_FORMAT, "Invalid block size : ".strlen($v_binary_data));

                  return PclZip::errorCode();
    }

                $v_data = unpack('vversion/vflag/vcompression/vmtime/vmdate/Vcrc/Vcompressed_size/Vsize/vfilename_len/vextra_len', $v_binary_data);

            $p_header['filename'] = fread($this->zip_fd, $v_data['filename_len']);
    
            if ($v_data['extra_len'] != 0) {
      $p_header['extra'] = fread($this->zip_fd, $v_data['extra_len']);
    }
    else {
      $p_header['extra'] = '';
    }
    
        $p_header['compression'] = $v_data['compression'];
        $p_header['size'] = $v_data['size'];
        $p_header['compressed_size'] = $v_data['compressed_size'];
        $p_header['crc'] = $v_data['crc'];
        $p_header['flag'] = $v_data['flag'];
    
        $p_header['mdate'] = $v_data['mdate'];
    $p_header['mtime'] = $v_data['mtime'];
    if ($p_header['mdate'] && $p_header['mtime'])
    {
            $v_hour = ($p_header['mtime'] & 0xF800) >> 11;
      $v_minute = ($p_header['mtime'] & 0x07E0) >> 5;
      $v_seconde = ($p_header['mtime'] & 0x001F)*2;

            $v_year = (($p_header['mdate'] & 0xFE00) >> 9) + 1980;
      $v_month = ($p_header['mdate'] & 0x01E0) >> 5;
      $v_day = $p_header['mdate'] & 0x001F;

            $p_header['mtime'] = mktime($v_hour, $v_minute, $v_seconde, $v_month, $v_day, $v_year);

          }
    else
    {
      $p_header['mtime'] = time();
          }

        $p_header['stored_filename'] = $p_header['filename'];

        $p_header['status'] = "ok";

            return $v_result;
  }
  
              function privReadCentralFileHeader(&$p_header)
  {
        $v_result=1;

        $v_binary_data = @fread($this->zip_fd, 4);
        $v_data = unpack('Vid', $v_binary_data);
    
        if ($v_data['id'] != 0x02014b50)
    {
      
            PclZip::privErrorLog(PCLZIP_ERR_BAD_FORMAT, 'Invalid archive structure');

                  return PclZip::errorCode();
    }

        $v_binary_data = fread($this->zip_fd, 42);

        if (strlen($v_binary_data) != 42)
    {
      $p_header['filename'] = "";
      $p_header['status'] = "invalid_header";
      
            PclZip::privErrorLog(PCLZIP_ERR_BAD_FORMAT, "Invalid block size : ".strlen($v_binary_data));

                  return PclZip::errorCode();
    }

                $p_header = unpack('vversion/vversion_extracted/vflag/vcompression/vmtime/vmdate/Vcrc/Vcompressed_size/Vsize/vfilename_len/vextra_len/vcomment_len/vdisk/vinternal/Vexternal/Voffset', $v_binary_data);

            if ($p_header['filename_len'] != 0)
      $p_header['filename'] = fread($this->zip_fd, $p_header['filename_len']);
    else
      $p_header['filename'] = '';
    
            if ($p_header['extra_len'] != 0)
      $p_header['extra'] = fread($this->zip_fd, $p_header['extra_len']);
    else
      $p_header['extra'] = '';
    
            if ($p_header['comment_len'] != 0)
      $p_header['comment'] = fread($this->zip_fd, $p_header['comment_len']);
    else
      $p_header['comment'] = '';
    
                                
        if ($p_header['mdate'] && $p_header['mtime'])
    {
            $v_hour = ($p_header['mtime'] & 0xF800) >> 11;
      $v_minute = ($p_header['mtime'] & 0x07E0) >> 5;
      $v_seconde = ($p_header['mtime'] & 0x001F)*2;

            $v_year = (($p_header['mdate'] & 0xFE00) >> 9) + 1980;
      $v_month = ($p_header['mdate'] & 0x01E0) >> 5;
      $v_day = $p_header['mdate'] & 0x001F;

            $p_header['mtime'] = mktime($v_hour, $v_minute, $v_seconde, $v_month, $v_day, $v_year);

          }
    else
    {
      $p_header['mtime'] = time();
          }

        $p_header['stored_filename'] = $p_header['filename'];

        $p_header['status'] = 'ok';

                if (substr($p_header['filename'], -1) == '/')
    {
      $p_header['external'] = 0x41FF0010;
          }

    
            return $v_result;
  }
  
              function privReadEndCentralDir(&$p_central_dir)
  {
        $v_result=1;

        $v_size = filesize($this->zipname);
        @fseek($this->zip_fd, $v_size);
        if (@ftell($this->zip_fd) != $v_size)
    {
            PclZip::privErrorLog(PCLZIP_ERR_BAD_FORMAT, 'Unable to go to the end of the archive \''.$this->zipname.'\'');

                  return PclZip::errorCode();
    }

            $v_found = 0;
    if ($v_size > 26) {
            @fseek($this->zip_fd, $v_size-22);
            if (($v_pos = @ftell($this->zip_fd)) != ($v_size-22))
      {
                PclZip::privErrorLog(PCLZIP_ERR_BAD_FORMAT, 'Unable to seek back to the middle of the archive \''.$this->zipname.'\'');

                        return PclZip::errorCode();
      }

            $v_binary_data = @fread($this->zip_fd, 4);
            $v_data = @unpack('Vid', $v_binary_data);
      
            if ($v_data['id'] == 0x06054b50) {
                $v_found = 1;
      }

      $v_pos = ftell($this->zip_fd);
    }

        if (!$v_found) {
            $v_maximum_size = 65557;       if ($v_maximum_size > $v_size)
        $v_maximum_size = $v_size;
      @fseek($this->zip_fd, $v_size-$v_maximum_size);
      if (@ftell($this->zip_fd) != ($v_size-$v_maximum_size))
      {
                PclZip::privErrorLog(PCLZIP_ERR_BAD_FORMAT, 'Unable to seek back to the middle of the archive \''.$this->zipname.'\'');

                        return PclZip::errorCode();
      }
      
            $v_pos = ftell($this->zip_fd);
      $v_bytes = 0x00000000;
      while ($v_pos < $v_size)
      {
                $v_byte = @fread($this->zip_fd, 1);

                $v_bytes = ($v_bytes << 8) | Ord($v_byte);

                if ($v_bytes == 0x504b0506)
        {
                    $v_pos++;
          break;
        }

        $v_pos++;
      }

            if ($v_pos == $v_size)
      {
        
                PclZip::privErrorLog(PCLZIP_ERR_BAD_FORMAT, "Unable to find End of Central Dir Record signature");

                        return PclZip::errorCode();
      }
    }

        $v_binary_data = fread($this->zip_fd, 18);

        if (strlen($v_binary_data) != 18)
    {
      
            PclZip::privErrorLog(PCLZIP_ERR_BAD_FORMAT, "Invalid End of Central Dir Record size : ".strlen($v_binary_data));

                  return PclZip::errorCode();
    }

                $v_data = unpack('vdisk/vdisk_start/vdisk_entries/ventries/Vsize/Voffset/vcomment_size', $v_binary_data);

            if (($v_pos + $v_data['comment_size'] + 18) != $v_size)
    {
      
            PclZip::privErrorLog(PCLZIP_ERR_BAD_FORMAT, "Fail to find the right signature");

                  return PclZip::errorCode();
    }

        if ($v_data['comment_size'] != 0)
      $p_central_dir['comment'] = fread($this->zip_fd, $v_data['comment_size']);
    else
      $p_central_dir['comment'] = '';
    
    $p_central_dir['entries'] = $v_data['entries'];
        $p_central_dir['disk_entries'] = $v_data['disk_entries'];
        $p_central_dir['offset'] = $v_data['offset'];
        $p_central_dir['size'] = $v_data['size'];
        $p_central_dir['disk'] = $v_data['disk'];
        $p_central_dir['disk_start'] = $v_data['disk_start'];
    
                
            return $v_result;
  }
  
                        function privDirCheck($p_dir, $p_is_dir=false)
  {
    $v_result = 1;

    
        if (($p_is_dir) && (substr($p_dir, -1)=='/'))
    {
      $p_dir = substr($p_dir, 0, strlen($p_dir)-1);
    }
    
        if ((is_dir($p_dir)) || ($p_dir == ""))
    {
            return 1;
    }

        $p_parent_dir = dirname($p_dir);
    
        if ($p_parent_dir != $p_dir)
    {
            if ($p_parent_dir != "")
      {
        if (($v_result = $this->privDirCheck($p_parent_dir)) != 1)
        {
                    return $v_result;
        }
      }
    }

            if (!@mkdir($p_dir, 0777))
    {
            PclZip::privErrorLog(PCLZIP_ERR_DIR_CREATE_FAIL, "Unable to create directory '$p_dir'");

                  return PclZip::errorCode();
    }

            return $v_result;
  }
  
  }
    
                        function PclZipUtilTranslateWinPath($p_path, $p_remove_disk_letter=true)
  {
    if (stristr(php_uname(), 'windows')) {
            if (($p_remove_disk_letter) && (($v_position = strpos($p_path, ':')) != false)) {
          $p_path = substr($p_path, $v_position+1);
      }
            if ((strpos($p_path, '\\') > 0) || (substr($p_path, 0,1) == '\\')) {
          $p_path = strtr($p_path, '\\', '/');
      }
    }
    return $p_path;
  }
  
?>
