<?php
if(!defined('_VALID')){header('Status: 404 Not Found');die;}
/* (C) 2006 by legolas558
	TarBackup class v0.1.1
	Licensed under GPL
	http://sf.net/projects/phptarbackup

 * This program is free software and open source software; you can redistribute
 * it and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  or visit
 * http://www.gnu.org/licenses/gpl.html
 */
 
include $d_root.'admin/classes/pcl/pcltar.lib.php';

define('__TBK_DEFAULT_CHUNK', 4 * 1024 * 1024);

define('__TBK_FNAME', 0);
define('__TBK_FSIZE', 1);
define('__TBK_ROOT', 2);
define('__TBK_TARNAME', 3);
define('__TBK_TOTAL', 4);
define('__TBK_DONE', 5);

class TarBackupSkel {
var $progress;

function TarBackupSkel(&$var) {
	$this->progress =& $var;
}

function _addFile($fn, $fs) {
	$this->progress[__TBK_FNAME][] = $fn;
	$this->progress[__TBK_FSIZE][] = $fs;
	$this->progress[__TBK_TOTAL] += $fs;
}

function _init($root, $p_tarname) {
	$this->progress = array(__TBK_FNAME => array(), __TBK_FSIZE => array(), __TBK_ROOT => $root, __TBK_TARNAME => $p_tarname, __TBK_DONE => 0, __TBK_TOTAL => 0);
}

function _pclexec($funcname, $args) {
	$er = error_reporting(-1 ^ E_NOTICE);

		$r = call_user_func_array($funcname, $args);

	error_reporting($er);
	if (!$r)
		trigger_error('PclTar: '.PclErrorString($r));

	return $this->Done();
}

function Done() {
	$this->finished = ($this->progress[__TBK_TOTAL] == $this->progress[__TBK_DONE]);
	if ($this->finished)
		return true;

	$this->progress[__TBK_FNAME] = array_slice($this->progress[__TBK_FNAME], $this->i+1);
	$this->progress[__TBK_FSIZE] = array_slice($this->progress[__TBK_FSIZE], $this->i+1);

	return true;
}

function _slice($max_bytes) {
	$done = 0;

	$c = count($this->progress[__TBK_FNAME]);
	for ($i=0;$i<$c;$i++) {
		$done += $this->progress[__TBK_FSIZE][$i];
		$lista[] = $this->progress[__TBK_FNAME][$i];
		if ($done>$max_bytes)
			break;
	}
	$this->progress[__TBK_DONE] += $done;

	$this->i = $i;

	return $lista;
}

function _loop($next_step_cb, $max_time, $method) {

	if ($max_time === null)
		$max_time = ini_get('max_execution_time');


	$start = mt_float();

	if ($this->$method()) {
		$this->_finalize($next_step_cb);
		return;
	}
	
	$chunks = ( ($max_time-1) / (mt_float() - $start));
	
	if ($this->$method( $chunks * __TBK_DEFAULT_CHUNK)) {
		$this->_finalize($next_step_cb);
		return;
	}

	while (!$this->$method()) {
		if (time()-$start>$max_time)
			break;
	}
	$this->_finalize($next_step_cb);
}


function _finalize($next_step_cb) {
	$next_step_cb(!$this->finished, $this->progress[__TBK_TOTAL], $this->progress[__TBK_DONE]);
	if ($this->finished) {	// will eventually free the associated session variable
		unset($this->progress[__TBK_FNAME]);
		unset($this->progress[__TBK_FSIZE]);
	}
}

}


class TarBackup extends TarBackupSkel {

function GetTarballName() {
	return $this->progress[__TBK_TARNAME];
}

function AddFile($fn) {
	$this->_addFile($fn, filesize($this->progress[__TBK_ROOT].$fn));
}

# How update works

# the list of files present into the Tar archive is retrieved
# if filename is of a directory and is not in the exclude list, it is added to the main list of updateable files
# files in an excluded directory are deleted (and the dellist is kept)
# otherwise if filename does not belong to an excluded path, add it

function BeginUpdate($root, $p_tarname, $exclude_list = array()) {
	$er = error_reporting(-1 ^ E_NOTICE);
	$list = PclTarList($p_tarname);

	$this->_init($root, $p_tarname);

	$this->dellist = array();
	foreach ($list as $fn) {
		if ($fn['filename']{strlen($fn['filename'])-1}=='/') {
			if (!in_array($fn['filename'], $exclude_list))
				$this->_recurseDir($fn['filename'], $exclude_list);
		} else {
			if (!path_matches($exclude_list, $fn['filename']))
				$this->_addFile($fn['filename'], $fn['size']);
			else
				$this->dellist[] = $fn['filename'];
		}
	}
	if (!empty($this->dellist)) {
		$er = error_reporting(-1 ^ E_NOTICE);
			PclTarDelete($this->progress[__TBK_TARNAME], $dellist);
		error_reporting($er);
	}
}

// mandatory: directory $dir must have a trailing slash
function _mydirname($dir) {
	return substr($dir,0,strlen($dir)-1);
}

function BeginCreation($root, $p_tarname = null, $exclude_list = array()) {

	if ($p_tarname == null)
		$p_tarname = $this->_mydirname($root).'.tgz';

	$this->_init($root, $p_tarname);

	$this->_recurseDir('', $exclude_list);	// start recursion from $root

	PclTarCreate($p_tarname);
}

	function _recurseDir($folder, &$exclude_list) {
		$dh = opendir($this->progress[__TBK_ROOT].$folder);
		$fc = 0;
		while (false !== ($file = readdir($dh))) {
			if ($file{0}=='.') continue;
			if (is_dir($this->progress[__TBK_ROOT].$folder.$file)) {
				if (in_array($folder.$file.'/', $exclude_list))
					continue;
				$fc += $this->_recurseDir($folder.$file.'/', $exclude_list);
			} else {
				$fc++;
				$this->AddFile($folder.$file);
			}
		}
		closedir($dh);
		if ($fc==0)	{ // add empty folders
			$this->progress[__TBK_FNAME][] = $folder;
			$this->progress[__TBK_FSIZE][] = 0;
			$fc++;
		}
		return $fc;
	}

function UpdateStep($max_bytes = __TBK_DEFAULT_CHUNK) {
	return $this->_pclexec('PclTarUpdate',
			array($this->progress[__TBK_TARNAME], $this->_slice($max_bytes),'','',
							$this->progress[__TBK_ROOT]));
}

function AddStep($max_bytes = __TBK_DEFAULT_CHUNK) {
	return $this->_pclexec('PclTarAddList', array($this->progress[__TBK_TARNAME], $this->_slice($max_bytes),'',
							$this->progress[__TBK_ROOT]));
}

function CreateBackup($next_step_cb, $max_time = null) {
	$this->_loop($next_step_cb, $max_time, 'AddStep');
}

function PerformUpdate($next_step_cb, $max_time = null) {
	$this->_loop($next_step_cb, $max_time, 'UpdateStep');
}

}

function array_walk_cond($arr, $funcname, $match) {
	$c=count($arr);
	for($i=0;$i<$c;$i++) {
		if ($funcname($arr[$i], $match))
			return true;
	}
	return false;
}

function path_matches($paths, $filename) {
	return array_walk_cond($paths, create_function('$value,$match','return (strpos($value, $match)===0);'), $filename);
}

function rev_path_matches($paths, $filename) {
	return array_walk_cond($paths, create_function('$match,$value','return (strpos($value, $match)===0);'), $filename);
}


?>