<?php if(!defined('_VALID')){header('Status: 404 Not Found');die;}
## Tarball backup component for Drake CMS
# @author legolas558
# Released under GNU GPL License
# This component is part of Drake CMS core
#
# HTML output functions
#

$skip_folders = array( $d_private.'backup/', $d_private.'cache/' );

//legolas558: tarball archiving
function manage_tar()
{
global $d_root,$d_private;
$gui=new ScriptedUI();
$gui->add("form","adminform");
$gui->add("com_header",_SYSTEM_TAR_BACKUP);

$table_head = array ( array('title'=>'#' , 'val'=>'id' , 'len'=>'1%','align'=>'center') ,
					  array('title'=>'checkbox' , 'val'=>'id' , 'len'=>'1%','align'=>'center') ,
					  array('title'=>_NAME,'val'=>'id','len'=>'70%','info'=>_DOWNLOAD,'ilink'=>
					  $d_private.'backup/ivar1','ivar1'=>'id') ,
					  array('title'=>_CDATE,'val'=>'created','len'=>'15%','date'=>'1','align'=>'center'),
					  array('title'=>_SIZE,'val'=>'size','len'=>'15%','align'=>'center') ,
					 );
$backup_dir=$d_root.$d_private."backup/";
$table_data=read_dir($backup_dir,"file",true, array('tar', 'tgz'));
$gui->add("data_table_arr","maintable",$table_head,$table_data);
$gui->add("end_form");
$gui->generate();
}

	function continue_job($total, $done) {
		global $gui;
		$gui->add("form_text","", '<strong>'.((int)($done*100/$total)).'%</strong> complete<br/>' );
		$gui->add("form_hidden", "step","", 2);

//		$gui->add("form_hidden", "tarbak_tgz","", $tarbak_tgz);
		return array(array('name'=> 'Next' , 'onclick'=>'javascript:document.adminform.submit()'));
	}

	function get_latest_sql() {
		global $d_root, $d_private;
		$sql_backups = read_dir($d_root.$d_private.'backup/',"file",true, array('php'));

		$chosen = false;
		$c=count($sql_backups);
		global $time;
		for ($i=0;$i<$c;$i++) {
			$p = strpos($sql_backups[$i]['id'], '_');
			if ($p===false) continue;
			$ts = intval(substr($sql_backups[$i]['id'], 0, $p));
			if (!$ts) continue;
			if ($time-$ts>=12 * 60 * 60) continue;
			$chosen = $d_private.'backup/'.$sql_backups[$i]['id'];
			break;
		}
		if ($chosen == false) {
			include $d_root.'admin/classes/dbbackup.php';
			$dbbak = new DbBackup();
			$chosen = $dbbak->Create();
			unset($dbbak);
		}
		return $chosen;
	}

function update_tarball($tar_fname, $step) {
	global $skip_folders, $d_root, $d_private, $gui;

	function update_cb($again, $total, $done) {
		global $gui,$d;
		if ($again) {
			$gui=new ScriptedUI();
			$gui->add("form","adminform");
			$gui->add("com_header",_SYSTEM_TAR_BACKUP);

			$gui->add("tab_head");
			$gui->add("tab_simple","", 'Archive update in progress');

			$button_arr = continue_job($total, $done);

			$gui->add("bar");
			$gui->add("form_buttons","","",$button_arr);

			$gui->add("tab_tail");
			$gui->add("end_form");
			$gui->generate();
		} else
			$d->Redir('admin.php?com_option=backup', 'Archive updated successfully');
	}

	include $d_root.'admin/classes/tarbackup.php';

	$tar = new TarBackup($_SESSION['tarbackup']);

	if ($step == 0) {

		$tar_fname = $d_root.$d_private.'backup/'.$tar_fname;
		$tar->BeginUpdate($d_root, $tar_fname, $skip_folders);

		if (rev_path_matches($tar->dellist, $d_private.'backup/')) {
			$chosen = get_latest_sql();
			$tar->AddFile($chosen);
		}

	} else if ($step == 2) {

		if (!isset($tar->progress))
			trigger_error('Session lost');
	}

	$tar->PerformUpdate('update_cb');
}

function new_tarball($step) {
global $gui;
$gui=new ScriptedUI();
$gui->add("form","adminform");
$gui->add("com_header",_SYSTEM_TAR_BACKUP);
	$gui->add("form_hidden", "task", '', 'new_tar');

	function continue_cb($again, $total, $done) {
		global $gui, $tarbak_dl,  $tar, $d_root;
		if ($again)
			$button_arr = continue_job($total, $done);
		else {

			$fn = $tar->GetTarballName();

			if ($tarbak_dl) {
				download($fn, filesize($fn));
				unlink($fn);
				exit;
			}

			$rp = substr($fn, strlen($d_root));
			$bn = basename($rp);
			$gui->add("form_text","", _SYSTEM_TARBAK_COMPLETE.'<br/><br/>'.
			'<big><a href="'.$rp.'">'.$bn.'</a></big> '.sprintf("%.2f", filesize($d_root.$rp)/(1024*1024)).' MB');
			$gui->add("form_hidden", "step","", 0);
			$gui->add("form_hidden", "tarbak_del","", $bn);
			$button_arr = array(
			array('name'=> 'Back' , 'onclick'=>"document.location='admin.php?com_option=backup'"),
						array('name'=> _DELETE , 'onclick'=>'javascript:document.adminform.submit()'));
			$gui->add("bar");
			$gui->add("form_text","", '<strong>Note:</strong> delete unused backup files after download');
		}
		$gui->add("bar");
		$gui->add("form_buttons","","",$button_arr);
	}

	switch ($step) {
	case 0:

	$gui->add("tab_head");
	$gui->add("tab_simple","", 'Select options for tarball archive creation');

	global $d_private;
	$gui->add("form_text","", 'Tarball archive will be saved into <strong>'.$d_private.'backup/</strong> folder<br/>Select the below option to start downloading the file right after the end of the process (can timeout, only for small sites)');
	$gui->add("form_boolean", 'tarbak_dl', 'Download when finished', 0);
	$gui->add("form_text","", 'If compression is disabled files will be stored in their full size');
	$gui->add("form_boolean", 'tarbak_tgz', 'Enable compression', 1);
//	$gui->add("form_text","", 'The auto-installer package will allow auto-extraction of the tarball archive' );
//	$gui->add("form_boolean", 'tarbak_inst', 'Create auto-installer', 0);
	global $d_db;
/*	if ($d_db == 'gladius') {
		$gui->add("form_text","", 'Your Gladius database files will be backed up as normal files');
	} else */{
		$gui->add("form_text","", 'Create an SQL backup if a backup made in the last 24 hours is not available; if you use a flat file database (like Gladius or SQLite) the SQL backup is not suggested (the database files would be already backed up)');
		$gui->add("form_boolean", 'tarbak_sql', 'Attach SQL database snapshot', 1);
	}
	$gui->add("form_hidden", "step","", 1);

	$button_arr = array(array('name'=> 'Proceed' , 'onclick'=>'javascript:document.adminform.submit()'));
	$gui->add("bar");
	$gui->add("form_buttons","","",$button_arr);

	break;
	case 1:
	global $d_root;

	// in case of timeout before step 2 we reset and force the script to try again

	$tarbak_sql = in_num('tarbak_sql', $_POST, 0);

	if ($tarbak_sql)
		$chosen = get_latest_sql();

	case 2:

	global $tarbak_dl, $tarbak_tgz;//, $tarbak_inst;
	$tarbak_dl = in_num('tarbak_dl', $_POST, 0);
	$tarbak_tgz = in_num('tarbak_tgz', $_POST, 0);
//	$tarbak_inst = in_num('tarbak_inst', $_POST, 0);

	$gui->add("tab_head");
	$gui->add("tab_simple","", 'Archiving');
	global $d_root;

	include $d_root.'admin/classes/tarbackup.php';

//	if ($tarbak_inst)	$skip[] = 'admin/classes/pcl/';
	global $tar, $skip_folders,$d_private;

	$tar = new TarBackup($_SESSION['tarbackup']);

	if ($step == 1) {

		$tar->BeginCreation($d_root, $d_root.$d_private.'backup/'.random_string(7).'_'.get_domain().'.'.( $tarbak_tgz ? 'tgz' : 'tar'), $skip_folders);

		if ($tarbak_sql)
	//FIXME: a duplicate of the sql is currently created...why?
			$tar->AddFile($chosen);

	} else
		if (!isset($tar->progress))
			trigger_error('Session lost');

	$tar->CreateBackup('continue_cb' );

	break;
	}

$gui->add("tab_tail");
$gui->add("end_form");
$gui->generate();

}

?>