<?php if(!defined('_VALID')){header('Status: 404 Not Found');die;}
## Subsites component for Drake CMS
# @author legolas558
# Released under GNU GPL License
# This component is part of Drake CMS core
#
# main subsites management script
#

include com_path($d_type);

function subsite_copyfolders($src, $to) {
	$folders = read_dir($src, 'dir');
	foreach ($folders as $dir) {
		if (!is_dir($to.$dir))
			mkdir($to.$dir);
		subsite_copyfiles($src.$dir.'/', $to.$dir.'/');
	}
}

function subsite_copyfiles($src, $to) {
	$files = read_dir($src, 'file');
	foreach ($files as $file)
		copy($src.$file, $to.$file);
}

function subsite_publication($online) {
	global $d_root, $d, $conn;
	$ids = in('cid', __ARR | __NUM, $_POST);
	foreach ($ids as $id) {
		$r = $conn->GetRow('SELECT subpath FROM #__subsites WHERE id = '.$id);
		$cfg = $d_root.$r['subpath'].$d_private;
		$configArr = $d->_getConfig($cfg);
		$configArr['d_online'] = $online;
		$d->_setConfig($cfg, $configArr);
	}
}

switch ($task) {
	case 'new':
		$clone = in('cid', __ARR0 | __NUM, $_POST, 0);
		subsite_edit($clone, 'create');
	break;
	case 'edit':
		if (null !== ($id = in('cid', __ARR0 | __NUM, $_POST)))
			subsite_edit($id, 'save');
	break;
	case 'save':
		if ( (null === ($id = in_num('id', $_POST))) ||
			('' === ($subpath = in_sql('subsite_path', $_POST, ''))) ||
			('' === ($p_subpath = in_sql('p_subpath', $_POST, '')))
		)
			$d->Redir('admin.php?com_option=subsites', _FORM_NC);
			
		if ($subpath{strlen($subpath)-1}!='/')
			$subpath.='/';

		if ($subpath != $p_subpath) {
			if (is_dir($d_root.$p_subpath))
				rename($d_root.$p_subpath, $d_root.$subpath);
			$conn->Execute('UPDATE #__subsites SET subpath = \''.$subpath.'\' WHERE id = '.$id);
			$msg = 'Changes succesfully applied';
		} else
			$msg = '';
		$d->Redir('admin.php?com_option=subsites', $msg);
	break;
	case 'create':
		if ( (null === ($clone_src = in_sql('src', $_POST))) ||
			('' === ($subpath = in_sql('subsite_path', $_POST, ''))) )
			$d->Redir('admin.php?com_option=subsites', _FORM_NC);
		
		if ($subpath{strlen($subpath)-1}!='/')
			$subpath.='/';

		if (is_dir($d_root.$subpath))
			$d->Redir('', _SUBSITES_DIR_EXISTS);

		$subfolders = array ('',
							substr($d_private, 0, strlen($d_private)-1),
							'public',
							'images',
							'images/banners',
							'images/icons',
							'images/gallery',
							'images/gallery/thumbs'
						);
		foreach ($subfolders as $dir) {
			if (!@mkdir($d_root.$subpath.$dir)) {
				$d->Redir('', _SUBSITES_CREATE_ERROR);
				break;
			}
		}
		
		subsite_copyfiles($d_root.$clone_src.'images/', $d_root.$subpath.'images/');
		subsite_copyfiles($d_root.$clone_src.'images/icons/', $d_root.$subpath.'images/icons/');
		subsite_copyfiles($d_root.$clone_src.'images/banners/', $d_root.$subpath.'images/banners/');
		subsite_copyfiles($d_root.$clone_src.'public/', $d_root.$subpath.'public/');
		subsite_copyfolders($d_root.$clone_src.'images/gallery/', $d_root.$subpath.'images/gallery/');
		subsite_copyfolders($d_root.$clone_src.'images/gallery/thumbs/', $d_root.$subpath.'images/gallery/thumbs/');
		copy($d_root.$clone_src.'404.php', $d_root.$subpath.'404.php');
		$configArr = $d->_getConfig($d_root.$clone_src.$d_private);
		$configArr['d_online'] = 0;
		$configArr['d_title'] .= ' subsite';
		$d->_setConfig($d_root.$subpath.$d_private, $configArr);
		unset($configArr);
		
		$conn->Execute('INSERT INTO #__subsites (subpath) VALUES( \''.$subpath.'\')');
		
		$pages = array('index.php', 'index2.php', 'admin.php', 'admin2.php', 'version.php');
		if ($clone_src !== '') {
			foreach ($pages as $page)
				copy($d_root.$clone_src.$page, $d_root.$subpath.$page);
		} else {
			foreach ($pages as $page) {
				$content = '<'."?php ## Subsite proxy for $page\n\n\$d_subpath = '../';\n\n\$d_private = '{$subpath}$d_private';\n\ninclude '../$page';\n\n?".'>';
				$f = fopen($d_root.$subpath.$page,'w');
				fwrite($f, $content);
				fclose($f);
				unset($content);
			}
		}
		
		$d->Redir($subpath.'admin.php?com_option=config');
	break;
	case 'delete':
		$ids = in('cid', __ARR | __NUM, $_POST);
		foreach ($ids as $id) {
			$row = $conn->GetArray('SELECT subpath FROM #__subsites WHERE id = '.$id);
			$dir = $d_root.$row[0]['subpath'];
			if (is_dir($dir))
				deldir($dir);
			$conn->Execute('DELETE FROM #__subsites WHERE id = '.$id);
		}
		$d->Redir('admin.php?com_option=subsites');
	break;
	case 'publish':
		subsite_publication(1);
		$d->Redir('admin.php?com_option=subsites');
	break;
	case 'unpublish':
		subsite_publication(0);
		$d->Redir('admin.php?com_option=subsites');
	break;
	default:
		subsites_table();
}

?>