<?php

/******************************************************************
   Projectname:   Automatic Keyword Generator
   Version:       0.1
   Author:        Ver Pangonilo <smp@limbofreak.com>
   Last modified: 14 July 2006
   Copyright (C): 2006 Ver Pangonilo, All Rights Reserved

   * GNU General Public License (Version 2, June 1991)
   *
   * This program is free software; you can redistribute
   * it and/or modify it under the terms of the GNU
   * General Public License as published by the Free
   * Software Foundation; either version 2 of the License,
   * or (at your option) any later version.
   *
   * This program is distributed in the hope that it will
   * be useful, but WITHOUT ANY WARRANTY; without even the
   * implied warranty of MERCHANTABILITY or FITNESS FOR A
   * PARTICULAR PURPOSE. See the GNU General Public License
   * for more details.

   Description:
   This class can generates automatically META Keywords for your 
   webn pages based on the contents of your articles. This will 
   eliminate the tedious process of thinking what will be the best
   keywords that suits your article. The basis of the keyword
   generation is the number of iterations any word or phrase
   occured within an article. 

******************************************************************/

class autokeyword {

var $contents;
var $keywords;

function autokeyword($words = NULL)
{
$this->contents = $words;
$this->keywords = $this->parse_words().$this->parse_2words().$this->parse_3words();
return $this->keywords;
}

//turn the site contents into an array
//then replace common html tags.
function replace_chars($chars = NULL)
{
//convert all characters to lower case  
$_content = strtolower($chars);
//replace most common punctuations
//and html tags chars.
$_content = str_replace (",", " ", $_content);
$_content = str_replace ("\n", " ", $_content);
$_content = str_replace (")", " ", $_content);
$_content = str_replace ("(", " ", $_content);
$_content = str_replace (".", " ", $_content);
$_content = str_replace ("'", " ", $_content);
$_content = str_replace ('"', " ", $_content);
$_content = str_replace ('<', " ", $_content);
$_content = str_replace ('>', " ", $_content);
$_content = str_replace (';', " ", $_content);
$_content = str_replace ('!', " ", $_content);
$_content = str_replace ('?', " ", $_content);
$_content = str_replace ('/', " ", $_content);
$_content = str_replace ('-', " ", $_content);
$_content = str_replace (':', " ", $_content);
$_content = str_replace ('+', " ", $_content);
$_content = str_replace ('=', " ", $_content);

return $_content;
}

//single words META KEYWORDS
function parse_words()
{
//list of commonly used words  
$common = array("able", "about", "above", "act", "add", "afraid", "after", "again", "against", "age", "ago", "agree", "all", "almost", "alone", "along", "already", "also", "although", "always", "am", "amount", "an", "and", "anger", "angry", "animal", "another", "answer", "any", "appear", "apple", "are", "arrive", "arm", "arms", "around", "arrive", "as", "ask", "at", "attempt", "aunt", "away", "back", "bad", "bag", "bay", "be", "became", "because", "become", "been", "before", "began", "begin", "behind", "being", "bell", "belong", "below", "beside", "best", "better", "between", "beyond", "big", "body", "bone", "born", "borrow", "both", "bottom", "box", "boy", "break", "bring", "brought", "bug", "built", "busy", "but", "buy", "by", "call", "came", "can", "cause", "choose", "close", "close", "consider", "come", "consider", "considerable", "contain", "continue", "could", "cry", "cut", "dare", "dark", "deal", "dear", "decide", "deep", "did", "die", "do", "does", "dog", "done", "doubt", "down", "during", "each", "ear", "early", "eat", "effort", "either", "else", "end", "enjoy", "enough", "enter", "even", "ever", "every", "except", "expect", "explain", "fail", "fall", "far", "fat", "favor", "fear", "feel", "feet", "fell", "felt", "few", "fill", "find", "fit", "fly", "follow", "for", "forever", "forget", "from", "front", "gave", "get", "gives", "goes", "gone", "good", "got", "gray", "great", "green", "grew", "grow", "guess", "had", "half", "hang", "happen", "has", "hat", "have", "he", "hear", "heard", "held", "hello", "help", "her", "here", "hers", "high", "hill", "him", "his", "hit", "hold", "hot", "how", "however", "I", "if", "ill", "in", "indeed", "instead", "into", "iron", "is", "it", "its", "just", "keep", "kept", "knew", "know", "known", "late", "least", "led", "left", "lend", "less", "let", "like", "likely", "likr", "lone", "long", "look", "lot", "make", "many", "may", "me", "mean", "met", "might", "mile", "mine", "moon", "more", "most", "move", "much", "must", "my", "near", "nearly", "necessary", "neither", "never", "next", "no", "none", "nor", "not", "note", "nothing", "now", "number", "of", "off", "often", "oh", "on", "once", "only", "or", "other", "ought", "our", "out", "please", "prepare", "probable", "pull", "pure", "push", "put", "raise", "ran", "rather", "reach", "realize", "reply", "require", "rest", "run", "said", "same", "sat", "saw", "say", "see", "seem", "seen", "self", "sell", "sent", "separate", "set", "shall", "she", "should", "side", "sign", "since", "so", "sold", "some", "soon", "sorry", "stay", "step", "stick", "still", "stood", "such", "sudden", "suppose", "take", "taken", "talk", "tall", "tell", "ten", "than", "thank", "that", "the", "their", "them", "then", "there", "therefore", "these", "they", "this", "those", "though", "through", "till", "to", "today", "told", "tomorrow", "too", "took", "tore", "tought", "toward", "tried", "tries", "trust", "try", "turn", "two", "under", "until", "up", "upon", "us", "use", "usual", "various", "verb", "very", "visit", "want", "was", "we", "well", "went", "were", "what", "when", "where", "whether", "which", "while", "white", "who", "whom", "whose", "why", "will", "with", "within", "without", "would", "yes", "yet", "you", "young", "your");
//create an array out of the site contents
$s = split(" ", $this->replace_chars($this->contents));
//initialize array
$k = array();
//iterate inside the array
foreach( $s as $key=>$val ) {
//delete single or two letter words and
//Add it to the list if the word is not 
//contained in the common words list.
if(strlen(trim($val)) > 2  && !in_array(trim($val), $common) ) 
$k[] = trim($val);
}
//count the words
$k = array_count_values($k);
//sort the words from
//highest count to the 
//lowest.
arsort($k);
$i = "";
foreach($k as $key=>$val) $i .= $key.", ";
//release unused variables
unset($k);
unset($s);

return $i;
}

function parse_2words()
{
//create an array out of the site contents
$x = split(" ", $this->replace_chars($this->contents));
//initilize array
$y = array();

for ($i=0; $i < count($x)-1; $i++) {
  //delete phrases lesser than 5 characters
   if( (strlen(trim($x[$i])) > 4) and (strlen(trim($x[$i+1])) > 4) ) 
   {
     $y[] = trim($x[$i])." ".trim($x[$i+1]);
   }
}

//count the 2 word phrases
$y = array_count_values($y);
//sort the words from
//highest count to the 
//lowest.
arsort($y);

$z = "";
foreach($y as $key=>$val) $z .= $key.", ";
//release unused variables
unset($y);
unset($x);

return $z;
}

function parse_3words()
{
//create an array out of the site contents
$a = split(" ", $this->replace_chars($this->contents));
//initilize array
$b = array();

for ($i=0; $i < count($a)-1; $i++) {
  //delete phrases lesser than 5 characters
   if( (strlen(trim($a[$i])) > 3) and (strlen(trim($a[$i+1])) > 3) and (strlen(trim($a[$i+2])) > 3) and (strlen(trim($a[$i]).trim($a[$i+1]).trim($a[$i+2])) > 12) ) 
   {
     $b[] = trim($a[$i])." ".trim($a[$i+1])." ".trim($a[$i+2]);
   }
}

//count the 3 word phrases
$b = array_count_values($b);
//sort the words from
//highest count to the 
//lowest.
arsort($b);

$c = "";
foreach($b as $key=>$val) $c .= $key.", ";
//release unused variables
unset($a);
unset($b);

return $c;
}

}
?>
