<?php
## Gladius  Database Engine
# @author legolas558
# @version 0.1
# Licensed under GNU General Public License (GPL)
#
#
# Gladius globals and constants
#

define('GLADIUS_HI_VER', 0);
define('GLADIUS_LO_VER', 1);

// fetch mode constants
define('GLADIUS_FETCH_DEFAULT',0);
define('GLADIUS_FETCH_NUM',1);
define('GLADIUS_FETCH_ASSOC',2);
define('GLADIUS_FETCH_BOTH',3);

// error constants
define('_G__SUCCESS', 0);
define('_G__MALFORMED_SQL', 1);
define('_G__UNRECON_SQL', 2);
define('_G__TABLE_NOT_FOUND', 3);
define('_G__INVALID_MAX_LENGTH', 4);
define('_G__INVALID_TYPE', 5);
define('_G__INVALID_DEFAULT', 6);
define('_G__MISS_CLS', 7);
define('_G__FIELD_NOT_FOUND', 8);
define('_G__DUPLICATE_PRIMARY', 9);
define('_G__FIELD_TYPE_MISMATCH', 11);
define('_G__FIELD_NOT_NULL', 12);
define('_G__EXCEED_MAX_LENGTH', 13);
define('_G__NOT_ENOUGH_FIELDS', 14);
define('_G__DUPLICATE_KEY', 15);
define('_G__TABLE_EXISTS', 16);
define('_G__INVALID_ALIAS', 17);
define('_G__AMBIGUOUS_FIELD', 18);
define('_G__TABLE_NOT_SELECTED', 19);
define('_G__NO_SOURCE', 20);
define('_G__CONVERSION_ERROR', 21);
define('_G__ASTERISK_AGAIN', 23);
define('_G__INVALID_LIMIT', 24);
define('_G__UNEXPECTED_CLOSEP', 25);
define('_G__BOOL_OP_EXPECTED', 26);
define('_G__INVALID_BOOL_OP', 27);
define('_G__LHAND_EXPECTED', 28);
define('_G__RHAND_EXPECTED', 29);
define('_G__OPERATOR_EXPECTED', 30);
define('_G__DUPLICATE_SOURCE', 31);
define('_G__TYPE_MISMATCH', 32);
define('_G__UNKNOWN_BOOL_OP', 33);
define('_G__DB_NOT_FOUND', 34);
define('_G__DB_ALREADY_EXISTS', 35);
define('_G__CANNOT_DROP_DB', 36);
define('_G__UNIQUE_VIOLATED', 37);
define('_G__AND_EXPECTED', 38);
define('_G__SET_EXPECTED', 39);
define('_G__TOO_MANY_FIELDS', 40);
define('_G__EXPECTED_OPP', 41);
define('_G__CANNOT_CREATE_DB', 42);
define('_G__COMMA_EXPECTED', 10);
define('_G__AMBIGUOUS_ALIAS', 22);

// other Gladius constants
define('_G__PHP_HEAD', '<'.'?php die;?'.'>');
define('_G__STRING', "('[^']*')+");
define('_G__UNIQUE', 'unique\\s+\\(\\s*([\\w,\\s]+)\\)');
define('_G__DATE_FORMAT', "%Y-%m-%d");
define('_G__TIME_FORMAT', "%H:%M:%S");
define('_G__DATETIME_FORMAT', _G__DATE_FORMAT.' '._G__TIME_FORMAT);
define('_G__COMPRESSION_THRESHOLD', 16000);

global $GLADIUS_BOOL_OPS, $GLADIUS_ERRORS, $GLADIUS_OPS, $GLADIUS_DB_ROOT, $GLADIUS_CUSTOM_DATA;

global $GLADIUS_RESERVED;

$GLADIUS_RESERVED = array('FROM', 'ORDER', 'GROUP', 'WHERE');

function gladius_reserved($word) {
	global $GLADIUS_RESERVED;
	return in_array(strtoupper($word), $GLADIUS_RESERVED);
}

$GLADIUS_ERRORS = array(
	_G__SUCCESS => '%s statement successfully executed, %d row%s affected',
	_G__MALFORMED_SQL => 'SQL syntax error',
	_G__UNRECON_SQL => 'Unrecognized SQL statement "%s"',
	_G__TABLE_NOT_FOUND => 'Table "%s" not found',
	_G__INVALID_MAX_LENGTH => 'Invalid value for maximum length',
	_G__INVALID_TYPE => 'Unsupported SQL data type "%s"',
	_G__MISS_CLS => 'Expected terminating \')\'',
	_G__FIELD_NOT_FOUND => 'Field "%s" not found in source tables',
	_G__INVALID_DEFAULT => 'Invalid default value "%s" specified for field "%s"',
	_G__DUPLICATE_PRIMARY => 'Primary key already defined for field "%s"',
	_G__FIELD_TYPE_MISMATCH => 'Type mismatch for field "%s", expected data of type %s',
	_G__FIELD_NOT_NULL => 'Field "%s" cannot be null',
	_G__EXCEED_MAX_LENGTH => 'Exceeded maximum length for field "%s" with value "%s"',
	_G__NOT_ENOUGH_FIELDS => 'Not enough fields to fill a record',
	_G__DUPLICATE_KEY => 'Cannot insert record with key "%d", it already exists',
	_G__TABLE_EXISTS => 'Table "%s" already exists',
	_G__INVALID_ALIAS => 'Invalid alias "%s"',
	_G__AMBIGUOUS_ALIAS => 'Ambiguous alias "%s" defined',
	_G__AMBIGUOUS_FIELD => 'Field "%s" is ambiguously referenced',
	_G__TABLE_NOT_SELECTED => 'Table "%s" was not selected',
	_G__NO_SOURCE => 'No source table specified',
	_G__CONVERSION_ERROR => '%s conversion error',
	_G__ASTERISK_AGAIN => 'Cannot use any field qualifer (*) again',
	_G__INVALID_LIMIT => 'Invalid limit boundaries specified',
	_G__UNEXPECTED_CLOSEP => 'Unexpected closing ")" found',
	_G__BOOL_OP_EXPECTED => 'Boolean operator expected',
	_G__INVALID_BOOL_OP => 'Invalid boolean operator "%s"',
	_G__LHAND_EXPECTED => 'Left hand operator expected',
	_G__RHAND_EXPECTED => 'Right hand operator expected',
	_G__OPERATOR_EXPECTED => 'Comparison operator expected',
	_G__DUPLICATE_SOURCE => 'Duplicate source "%s" in tables list',
	_G__TYPE_MISMATCH => 'Type mismatch, left hand is of type "%s" and right hand is of type "%s"',
	_G__UNKNOWN_BOOL_OP => 'Unknown boolean operator "%s"',
	_G__DB_NOT_FOUND => 'Database folder "%s" not found',
	_G__DB_ALREADY_EXISTS => 'Database folder "%s" already exists',
	_G__CANNOT_DROP_DB => 'Cannot drop database "%s"',
	_G__CANNOT_CREATE_DB => 'Cannot create database "%s"',
	_G__UNIQUE_VIOLATED => 'Unique constraint violated for field "%s"',
	_G__AND_EXPECTED => 'AND expected in BETWEEN expression',
	_G__SET_EXPECTED => 'Explicit values set or SELECT subquery expected',
	_G__TOO_MANY_FIELDS => 'Too many fields in subquery expression',
	_G__EXPECTED_OPP => 'Opening parenthesis "(" expected',
	_G__COMMA_EXPECTED => 'Comma character "," was expected',
);

$GLADIUS_OPS = array(
	'=' => 'equ',
	'>=' => 'geq',
	'>=' => 'leq',
	'<>' => 'nequ',
	'like' => 'like',
	'nlike' => 'nlike',
	'between' => 'between',
	'nbetween' => 'nbetween',
	);

$GLADIUS_BOOL_OPS = array(
	'or',
	'and',
	'nor',
	'nand'
	);
	
$GLADIUS_CUSTOM_DATA = array(
'datetime',
'date',
'time',
);

if (!isset($GLADIUS_DB_ROOT))
	$GLADIUS_DB_ROOT = '';

?>