<?php
## Gladius  Database Engine
# @author legolas558
# @version 0.1
# Licensed under GNU General Public License (GPL)
#
#
# CREATE command interpretation
#
	$this->offset = $m[1][1]+6;
	if (!preg_match('/\\s+table\\s+(\\w+)(\\s*\\(\\s*)/iA', $sql, $m,
			PREG_OFFSET_CAPTURE, $this->offset)) {
			if (preg_match('/\\s+database\\s+(\\w+)/iA', $sql, $m,
				PREG_OFFSET_CAPTURE, $this->offset)) {
					$database = $m[1][0];
					$this->offset = $m[1][1]+strlen($database);
					include_once 'gladius_create_database.php';
					return _create_database($this, $database);
				}
			$this->_error(_G__MALFORMED_SQL);
			return false;
	}

	$table = strtoupper($m[1][0]);

	if (file_exists($this->database.$table.'.php')) {
		$this->_error(_G__TABLE_EXISTS, $table);
		return false;
	}

	$this->offset = $m[2][1] + strlen($m[2][0]);

	$fields = array();
	while (preg_match(
		'/\\s*('.
		'(primary\\s+key\\s+\\(\\s*(\\w+)\\s*\\))'.	// primary key definition
		'|('._G__UNIQUE.')'.
		'|'.
		'((\\w+)\\s+(\\w+)\\s*'.			// field name and type
		'(\\(\\s*(\\d+)\\s*\\))?\\s*'.		// eventual field size definition
		'(auto_inc(rement)?)?\\s*'.			// \\s+ cannot be used in subexpression... :(
		'(not\\s*null)?\\s*'.
		'(unique)?\\s*'.
		'(default\\s*('._G__STRING.'|\\d+))?)'. // field definition
		')\\s*(,|\\))'.	// trailing comma or parenthesis
		'/iA', $sql, $m, PREG_OFFSET_CAPTURE, $this->offset)) {

//		{echo'<pre>';var_dump($m);echo'</pre>';}

		$this->offset = $m[count($m)-1][1]+1;

		if (preg_match('/primary/iA', $m[2][0])) {
			if (isset($primary)) {
				$this->_error(_G__DUPLICATE_PRIMARY, $primary);
				return false;
			}

		$primary = strtoupper($m[3][0]);

		if (!isset($fields[$primary])) {
			$this->_error(_G__FIELD_NOT_FOUND, $primary);
			return false;
		}

		$fields[$primary]->primary = true;

		if (!$this->_close_ok($m, $ok))
			return false;

		continue;
	} elseif (preg_match('/'._G__UNIQUE.'/iA', $m[4][0], $unique_raw)) {
		$u_fields = explode(',', $unique_raw[1]);
		foreach($u_fields as $field) {
			$field = strtoupper(trim($field));
			if (!isset($fields[$field])) {
				$this->_error(_G__FIELD_NOT_FOUND, $field);
				return false;
			}
			$fields[$field]->unique = true;
		}
		if (!$this->_close_ok($m, $ok))
			return false;
		continue;
	}

//					echo $m[8][0].'<br>';

	// create the new field object
	$fo = new stdClass;
	$fo->name = strtoupper($m[7][0]);
	$fo->table = $table;
	$fo->primary = false;
	$fo->not_null = !empty($m[13][0]);
	$fo->default = null;
	$fo->alias = strtolower($fo->name);
	$fo->unique = !empty($m[14][0]);
	$fo->indexed = false;
	$fo->ordered = array();	// pre-ordered indexes, if present

	if (!$this->_recon_sql_type($m[8][0], $fo)) {
		$this->_error(_G__INVALID_TYPE, $m[8][0]);
		return false;
	}

	// check for the maximum length parameter
	//TODO: implement consistent (scale,precision) on DECIMAL and NUMERIC field types
	if (!empty($m[9][0])) {
		$max_val = $m[10][0];
		if (((!ctype_digit($max_val))
			or ($max_val<1)
//			or ($fo->numeric && $max_val>64)
			)) {
			$this->_error(_G__INVALID_MAX_LENGTH, $max_val);
			return false;
		} else {
			$max_val = (int)$max_val;
			if (!$fo->numeric && ($max_val>65535)) {
				$this->_error(_G__INVALID_MAX_LENGTH, $max_val);
				return false;
			}
			$fo->max_length = $max_val;
		}
	}

	// analyze the default value
	$def = $m[16][0];
	if (strlen($def)!=0) {
		if (!$this->_retrieve_value($def, $fo, $fo->default)) {
			$this->_error(_G__INVALID_DEFAULT, $m[16][0], $fo->name);
			return false;
		}
	}

	if (!$this->_close_ok($m, $ok))
		return false;

	$fields[$fo->name] = $fo;
	} // loop for each field definition
	if (!isset($ok)) { // a valid termination is missing
		$this->_error(_G__MISS_CLS);
		return false;
	}

	$schema = array(
					'FIELD_DEF' => $fields,		// complete definitions for fields
					'LAST_INSERT_ID' => 0,
					'RECORD_IDS' => array(),	// always progressive record ID for internal or PRIMARY use
					// Gladius version, added to each table schema
					'GV' => (int)((GLADIUS_HI_VER << 16) | (GLADIUS_LO_VER))
				);
	gladius_save($this->database.$table.'.php', $schema);

	$this->_create_table($table, $schema);

	$this->_success(0);
	return true;
?>