<?php
## Gladius Database Engine
# @author legolas558
# @version 0.1
# Licensed under GNU General Public License (GPL)
#
#
# DELETE command interpretation
#
	if (!preg_match('/\\s*from\\s*(\\w+)/iA', $sql, $m, PREG_OFFSET_CAPTURE, $m[1][1]+6)) {
		$this->_error(_G__MALFORMED_SQL);
		return false;
	}
	$table = strtoupper($m[1][0]);
	$this->offset = $m[1][1]+strlen($table)+1;
	$from = array( array($table, '') );

	if (!$this->_hold_schema($table))
		return false;

	if (false ===($rs = $this->_create_rs($from)))
		return false;

	if (!$rs->_parse_where_expr($sql))
		return false;

	if (!$rs->_parse_limit($sql)) {
		$this->_error(_G__INVALID_LIMIT);
		return false;
	}

	$rs->initiate();	// can be optimized
	
	if (empty($rs->where_fields)) {
		if ($rs->limit_length != 0)
			$span = $rs->limit_length;
		else
			$span = count($this->schemas[$table]['RECORD_IDS']);
		$rs->iteration_arg = array( array($rs->limit_from, $span) );
	} else {
		foreach($rs->where_fields as $field) {
			$fo =& $rs->allfields[$field];
			$this->_hold_column($fo->table, $fo->name);
		}

		while ($rs->_iterate('_delete_row')) { }
		
		if (empty($rs->iteration_arg)) {

			$this->_success(0);
			return true;
		}
	}

	$fields = array_keys($this->schemas[$table]['FIELD_DEF']);
	foreach ($fields as $field) {
		$this->_hold_column($table, $field);
		$column =& $this->pool[$table][$field];

		$delta = 0;
		foreach ($rs->iteration_arg as $range) {
			array_splice($column, $range[0]-$delta, $range[1]);
			$delta += $range[1];
		}

		$fo =& $this->schemas[$table]['FIELD_DEF'][$field];
		if ($fo->indexed)
			$rs->_remove_order($fo, $rs->iteration_arg);

		$path = $this->database.$table.'.'.$field.'.php';
		gladius_save($path, $column);
	}

	$delta = 0;
	foreach ($rs->iteration_arg as $range) {
		array_splice($this->schemas[$table]['RECORD_IDS'], $range[0] - $delta, $range[1]);
		$delta += $range[1];
	}

	gladius_save($this->database.$table.'.php', $this->schemas[$table]);

	$this->_success($delta);
	return true;
?>