<?php
## Gladius Database Engine
# @author legolas558
# @version 0.1
# Licensed under GNU General Public License (GPL)
#
#
# INSERT command interpretation
#
	if (!preg_match('/\\s+into\\s+(\\w+)\\s*(\\([\\w\\s,]+\\))?\\s*values\\s*\\((.)/iA',
		$sql, $m, PREG_OFFSET_CAPTURE, $m[1][1]+6)) {
//					echo substr($sql, $m[1][1]+6).'<br>';
		$this->_error(_G__MALFORMED_SQL);
		return false;
	}

	$table = strtoupper($m[1][0]);

	if (!$this->_hold_schema($table))
		return false;
	$schema =& $this->schemas[$table];

	$smart_insert = empty($m[2][0]);
	if ($smart_insert)
		$fields = $schema['FIELD_DEF'];
	else {
		$fields_list = preg_replace('/\\s/', '', substr($m[2][0], 1, strlen($m[2][0])-2));

		$selected = explode(',', $fields_list);
		foreach($selected as $field) {
			$field = strtoupper($field);
			if (!isset($schema['FIELD_DEF'][$field])) {
				$this->_error(_G__FIELD_NOT_FOUND, $field);
				return false;
			}
		$fields[$field] =& $schema['FIELD_DEF'][$field];
		}
	}

	$this->offset = $m[3][1];
	$record = array();
/*	while( preg_match('/('._G__STRING.'|\\d+\\.\\d+|\\d+|NULL)\\s*(,|\\))?/i', $sql, $m,
						PREG_OFFSET_CAPTURE, $this->offset) ) {	*/

	do {
		$fo =& $fields[key($fields)];
		if (
			(false === ($retrieved = $this->_get_hand_imm($sql))) ||
			!$this->_retrieve_value($retrieved->evaluate(), $fo, $record[$fo->name]) ||
			!preg_match('/\\s*(,|\\))/A', $sql, $m, PREG_OFFSET_CAPTURE, $this->offset)
			) {
			$this->_error(_G__MALFORMED_SQL);
			return false;
		}

		$this->offset = $m[1][1]+1;

		switch ($m[1][0]) {
			case ')':
				break 2;
			case ',':
			break;
			default:
				$this->_error(_G__MALFORMED_SQL);
				return false;
		}

		next($fields);
	} while (true); // loop for each field value

	if (!$smart_insert and (count($record) != count($fields))) {
		$this->_error(_G__NOT_ENOUGH_FIELDS);
		return false;
	}

	//reset($fields);

/*	if (!$smart_insert)
		$fdef =& $fields;
	else	*/
	$fdef =& $schema['FIELD_DEF'];
	$required = array_keys($fdef);

	foreach($required as $field) {
		if (isset($record[$field])) {
			if ($fdef[$field]->primary) {
				if (in_array($record[$field], $schema['RECORD_IDS'])) {
					$this->_error(_G__DUPLICATE_KEY, $record[$field]);
					return false;
				}
				// if the new id is greater than the current one, overwrite it
				if ($record[$field] > $schema['LAST_INSERT_ID'])
					$schema['LAST_INSERT_ID'] = $record[$field];
			}
			if (!$this->_append_record($table, $fdef[$field], $record[$field]))
				return false;
		} else { // record is not set
			if ($fdef[$field]->primary) {
				if (!$this->_append_record($table, $fdef[$field],
									  ++$schema['LAST_INSERT_ID']))
					return false;
				}
			else { // this is not the primary key
				if (!isset($fdef[$field]->default) and
					$fdef[$field]->not_null) {
					$this->_error(_G__FIELD_NOT_NULL, $field);
					return false;
				}
				if (!$this->_append_record($table, $fdef[$field], $fdef[$field]->default))
					return false;
			}
		}
	}

	$schema['RECORD_IDS'][] = $schema['LAST_INSERT_ID'];

	gladius_save($this->database.$table.'.php', $schema);
	
	$this->insert_id = $schema['LAST_INSERT_ID'];

	$this->_success(1);
	return true;
?>