<?php
## Gladius Database Engine
# @author legolas558
# @version 0.1
# Licensed under GNU General Public License (GPL)
#
#
# Flatfile php database engine SQL92 compliant
#
# Resultset class
#

/* currently unused - parked here
class Gladius_Resultset_empty
{
	var $fields = false;
	var $EOF = true;
	function MoveNext($rowNumber) {return false;}
	function Move($rowNumber) {return false;}
	function MoveFirst($rowNumber) {return false;}
	function MoveLast($rowNumber) {return false;}
	function RecordCount() {return 0;}
	function FieldCount() {return 0;}
	function EOF(){return true;}
	function Close(){return true;}
}
*/

class Gladius_Resultset extends Gladius_Core
{
	var $fetch_mode;
	var $EOF;
	var $BOF;

	var $where_fields;
	var $order_fields;
	var $sorting;		// sorting settings (natural, ascending, descending)
	var $limit_from;
	var $limit_length;
	var $rowset;
	var $current_row;
	var $row_count;
	var $row_index;
	var $keys;

	var $t;				// current head table queried
	var $tot_t;			// count of tables
	var $EOR;
	var $iteration_arg;
	var $conn;
	var $in_subquery;

	var $where;			// filtering tree
	var $allfields;
	var $fields;
	var $tables;		// table/aliases	names
	var $sources;


	/**
	 * gladiusResultSet Constructor
	 *
	 * @access private
	 * @param string $record
	 * @param string $resultId
	 */

	function Gladius_ResultSet(&$conn)
	{
		$this->_command =& $conn->command;
		$this->offset =& $conn->offset;
		$this->errno =& $conn->errno;
		$this->errstr =& $conn->errstr;
		$this->_class_init();
//		$this->conn =& $conn;

		$this->conn =& $conn;
		$this->fetch_mode = $conn->fetch_mode;
	}

	function _class_init() {
		$this->fields = array();		// field definitions involved
		$this->allfields = array();		// both result and where fields here
		$this->rowset = array();

		$this->where = new begin_expr();
		$this->where_fields = array();
		$this->order_fields = array();
		$this->iteration_arg = array();
		$this->order_way = array();
		$this->in_subquery = false;

		$this->keys = array();

		$this->current_row = -1;
		$this->EOF = true;
		$this->BOF = true;
		$this->EOR = false;
	}

	/**
	 * Frees resultset
	 *
	 * @access public
	 */

	function Close()
	{
		$this->_class_init();
	}

	/**
	 * Returns field name from select query
	 *
	 * @access public
	 * @param int $field (column)
	 * @return string Field name
	 */

	function Fields( $field = null )
	{
		if($field === null)
			return $this->aliases;
		else
			return $fields[$field]->name;
	}

	/**
	 * Returns numrows from select query
	 *
	 * @access public
	 * @return integer Numrows
	 */

	function RecordCount()
	{
		if (!$this->EOR) {
			while ($this->_iterate('_fetch_row')) {	}
			$this->affected_rows = $this->row_count;
		}
		return $this->row_count;
	}

	/**
	 * Returns num of fields from select query
	 *
	 * @access public
	 * @return integer numfields
	 */

	function FieldCount()
	{
		return count($this->fields);
	}

	/**
	 * Returns next record
	 *
	 * @access public
	 */

	function MoveNext()
	{
		return $this->Move($this->current_row + 1);
	}

	/**
	 * Move to the first row in the recordset. Many databases do NOT support this.
	 *
	 * @return true or false
	 * NOT SUPPORTED
	 */

	function MoveFirst()
	{
		return $this->Move(0);
	}

	/**
	 * Returns the Last Record
	 * NOT SUPPORTED
	 *
	 * @access public
	 */

	function MoveLast()
	{
		return $this->Move($this->RecordCount() - 1);
	}

	/**
	 * Random access to a specific row in the recordset.
	 *
	 * @param rowNumber is the row to move to (0-based)
	 *
	 * @return true if there still rows available, or false if there are no more rows (EOF).
	 */

	function Move($rowNumber)
	{
		if ($rowNumber == $this->current_row)
			return true;

		if ($rowNumber >= $this->row_count) {

			if ($this->EOR) {
				$this->current_row = $this->row_count-1;
				$this->EOF = true;
				return false;
			}

			$this->affected_rows = $this->row_count;
			while ($this->_iterate('_fetch_row')) {
				if ($this->row_count-1==$rowNumber) {
					$this->current_row = $rowNumber;
					$this->EOF = false;
					return true;
				}
			}
			$this->affected_rows = $this->row_count - $this->affected_rows;
			$this->current_row = $this->row_count - 1;
			$this->EOF = true;
			return false;
		}
		if ($rowNumber<0)
			return false;

		$this->EOF = false;
		$this->current_row = $rowNumber;

		return true;
	}

	function _reset_tables() {
//		rsort($this->tables);	// ?
		$this->tot_t = count($this->tables);
		$this->t = 0;
		foreach ($this->tables as $table)
			reset($this->sources[$table]['RECORD_IDS']);
	}

	function _update_row() {
		$this->_delete_row();
		foreach($this->ops as $key => $hand) {
			$this->updated[$key][] = $hand->evaluate();
		}
	}

	function _delete_row() {
		if (!empty($this->iteration_arg)) {
			$last =& $this->iteration_arg[count($this->iteration_arg)-1];
			if ($this->row_index == $last[0]+$last[1]) {
				$last[1]++;
				return;
			}
		}
		$this->iteration_arg[] = array($this->row_index, 1);
	}

	function recompile_rowset() {
		$compiled = array();
		if ($this->limit_length)
			$max = min($this->row_count, $this->limit_from + $this->limit_length);
		else
			$max = $this->row_count;
		for($i=$this->limit_from;$i<$max;$i++) {
			$record = array();
			switch ($this->fetch_mode) {
				case GLADIUS_FETCH_BOTH:
					$record = array_slice($this->rowset[$i], 0, count($this->aliases));
					$c = 0;
					foreach ($this->aliases as $field) {
						$record[$field] =& $record[$c++];
					}
				break;
				case GLADIUS_FETCH_NUM:
					$record = array_slice($this->rowset[$i], 0, count($this->aliases));
				break;
				default:
				case GLADIUS_FETCH_DEFAULT:
				case GLADIUS_FETCH_ASSOC:
					$c = 0;
					foreach ($this->aliases as $field) {
						$record[$field] = $this->rowset[$i][$c++];
					}
				break;
			}
			$this->_decode_record($record);
			$compiled[] = $record;
		}
		unset($this->rowset);
		$this->rowset =& $compiled;
		$this->row_count = $max;
	}

	function _decode_record(&$record) {
		if (empty($this->keys))
			return;
		foreach ($this->keys as $key => $field) {
			$decfunc = 'gladius_'.$this->fields[$key]->type.'_dec';
			if (!$decfunc($record[$field], $record[$field]))
				die('GRTE: fatal error while decoding');
		}
	}

	function _order_fetch() {

		$this->_fetch_fields($this->iteration_arg);

		$fields = array_keys($this->fields);
		$record = array();
		while ($field = current($fields)) {
			$record[] = $this->fields[$field]->value;
			next($fields);
		}
		reset($this->order_fields);
		while (false !== ($field = current($this->order_fields))) {
			$record[] = $this->allfields[$field]->value;
			next($this->order_fields);
		}
/*		if ($this->fetch_mode != GLADIUS_FETCH_NUM) {
			reset($fields);
			$i=0;
			foreach ($fields as $field)
				$record[strtolower($field)] =& $record[$i++];
		}*/

		$this->rowset[] = $record;
	}

	// load values from fields and compile a new row of the rowset
	function _fetch_row() {

		$this->_fetch_fields($this->iteration_arg);

		switch ($this->fetch_mode) {
			case GLADIUS_FETCH_BOTH:
				$i=0;
				foreach ($this->fields as $fo) {
					$record[$i] = $fo->value;
					$record[$fo->alias] =& $record[$i];
					$i++;
				}
			break;
			case GLADIUS_FETCH_NUM:
				foreach ($this->fields as $fo) {
					$record[] = $fo->value;
				}
			break;
			default:
			case GLADIUS_FETCH_DEFAULT:
			case GLADIUS_FETCH_ASSOC:
				foreach ($this->fields as $fo) {
					$record[$fo->alias] = $fo->value;
				}
			break;
		}
		$this->_decode_record($record);
		$this->rowset[] = $record;
	}

	function _fetch_fields($fields) {
		// copy data into the fields
		foreach($fields as $field) {
			$column =& $this->conn->pool[$this->allfields[$field]->table][$field];
			$this->allfields[$field]->value = $column[$this->row_index];
		}
	}

	// remove some unused members
	function _compact() {
		unset($this->iteration_arg);
		unset($this->where_fields);
		unset($this->allfields);
		unset($this->tables);
		unset($this->sources);
	}

	function initiate() {
		// relative cursor in resultset being built
		$this->row_count = 0;
		$this->_reset_tables();
//		$this->row_index = key($this->sources[$this->tables[$this->t]]['RECORD_IDS']);
		$this->EOR = (current($this->sources[$this->tables[$this->t]]['RECORD_IDS']) === false);
	}

	function _upd_cursor() {
		$this->row_index = key($this->sources[$this->tables[$this->t]]['RECORD_IDS']);
		$this->EOR = (next($this->sources[$this->tables[$this->t]]['RECORD_IDS']) === false);
	}

	// fetch the next row
	function _iterate( $iterate_method ) {
		$skipped = 0;
		$delta = 1;

		do {
			if (($this->limit_length - $this->row_count == 0) && ($this->row_count!=0)) {
				$this->EOR = true;
				$this->_compact();
				return false;
			}

			// if one table has gone EOF get the next one
			if ($this->EOR) {

				for ($it = $this->t; $it < $this->tot_t; $it++) {
					reset($this->sources[$this->tables[$it]]['RECORD_IDS']);
				}
				$this->t++;
				// if all tables have gone EOF end querying of the resultset
				if ($this->t == $this->tot_t)
					return false;
				$this->_upd_cursor();
				$this->EOR = false;
				continue;
			}
			$this->_upd_cursor();

			// load the where fields
			$this->_fetch_fields($this->where_fields);

			// test the next row
			if ($this->where->test()) {

				// check if we need to skip the row
				if ($skipped < $this->limit_from) {
					$skipped++;
					continue;
				}

				$this->$iterate_method();

				$this->row_count++;
			} else
				continue;
			break;
		} while (true);
		return true;
	}

	/**
	 * Check to see if last record reached
	 *
	 * @access public
	 */

	function EOF()
	{
		if( $this->current_row < $this->row_count)
			return false;
		else {
			$this->EOF = true;
			return true;
		}
	}

	/**
	 * Returns All Records in an array
	 *
	 * @access public
	 * @param [nRows]  is the number of rows to return. -1 means every row.
	 * MoveNext() should be used for row-relative output generation
	 */

	function GetArray($nRows = -1)
	{
		$results = array();
		$cnt = 0;

		while (($nRows != $cnt) && ($this->MoveNext())) {

			$results[] =& $this->rowset[$this->current_row];

			$cnt++;
/*			if ($cnt==2) {
				$dbg = @debug_backtrace();
				if ($dbg) {
					$dbginfo = @$dbg[1]['file'].':'.@$dbg[1]['line'].' '.$dbg[1]['function'].'() ';
				} else
					$dbginfo = '';
				// replace with trigger_error
				$this->_log($dbginfo.'It is advised to use MoveNext() when iterating through resultset rows', E_USER_NOTICE);
			}	*/
		}
		return $results;
	}

	function GetRow() {
		$row_a = $this->GetArray(1);
		if (empty($row_a))
			return array();
		return $row_a[0];
	}

	function GetRows($nRows = -1)
	{
		return $this->GetArray($nRows);
	}

	function GetAll()
	{
		return $this->GetArray();
	}

	/**
	* Fetch field information for a table.
	*
	* @return object containing the name, type and max_length
	*/
	function FetchField($fieldOffset = -1)
	{
		if ($field_offset == -1)
			return array_values($this->fields);

		while (($field_offset>0) && next($this->fields)) {
			$field_offset++;
		}
		$fieldObject = current($this->fields);
		reset($this->fields);
		return $fieldObject;
	}

	/**
	* Scan $expr expression for preg-escaped string $sym
	*
	* @access private
	* @return true if $sym was found ($offset is properly updated), false otherwise
	*/
	function _sym(&$sql, $sym) {
		if (preg_match('/\\s*('.$sym.')/A', $sql, $m, PREG_OFFSET_CAPTURE, $this->offset)) {
			$this->offset = $m[1][1]+1;
			return true;
		}
		return false;
	}

	function _opening_p(&$sql) {
		return $this->_sym($sql, '\\(');
	}

	function _closing_p(&$sql) {
		return $this->_sym($sql, '\\)');
	}

	function _parse_where_expr(&$sql, $endch = '$') {

		if (!preg_match('/\\s*where\\s+(.)/iA',
					$sql, $m, PREG_OFFSET_CAPTURE, $this->offset))
			return true;
		$this->offset = $m[1][1];

		$current =& $this->where;
		$boolean_op = 'and';
		$stack = array();

//		echo '<b>PARSED CHAIN <big>[</big></b><br/>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';

		do {
			if ($this->_opening_p($sql)) {
//				echo '<big style="color:green; font-weight:bold">CHAIN(</big>';
				$current->bool_op = $boolean_op;
				$current->next = new begin_expr();
				$stack[] =& $current;
				$current =& $current->next;
				$boolean_op = null;
			}

			$current->bool_op = $boolean_op;
			$current->next = $this->_parse_one_expr($sql);
			$current =& $current->next;

			if ($this->_closing_p($sql)) {
//				echo '<big style="color:green; font-weight:bold">)</big>';
				if (empty($stack)) {
					if ($this->in_subquery)
						return true;
					$this->_error(_G__UNEXPECTED_CLOSEP);
					return false;
				}

				$parent = array_pop($stack);
				$current =& $parent;
			}

			// subquery parenthesis are needed
			if (preg_match('/\\s*(order|group|limit|;?\\s*$)/iA', $sql, $break_exp, 0, $this->offset))
				break;

			if (false === ($boolean_op = $this->_get_boolean($sql))) {
				$this->_error(_G__BOOL_OP_EXPECTED);
				return false;
			}

		} while (true);

		//TODO: check for $endch matching in $break_exp

//		echo '<br/><b><big>]</big></b><br/>';
		return true;
	}

	function _get_boolean(&$expr) {
		$boolean = $this->_get_boolean_op($expr);
		if (!$boolean)
			return false;
		$backup = $this->offset;
		$not = $this->_get_boolean_op($expr);
		if ($not == 'not')
			$boolean = 'n'.$boolean;
		else
			$this->offset = $backup;

		global $GLADIUS_BOOL_OPS;
		if (!in_array($boolean, $GLADIUS_BOOL_OPS)) {
			$this->_error(_G__INVALID_BOOL_OP, $boolean);
			return false;
		}

//		echo '<i style="font-family:tahoma">'.strtoupper($boolean).'</i> ';
		return $boolean;
	}

	function &_get_where_field($table_name, $name) {
		$fo = null;
		if ($table_name!='') {
			if (!isset($this->sources[$table_name])) {
				$this->_error(_G__TABLE_NOT_FOUND, $table_name);
				return $fo;
			}
			if (!isset($this->sources[$table_name]['FIELD_DEF'][$name])) {
				$this->_error(_G__FIELD_NOT_FOUND, $name);
				return $fo;
			}
			$fo =& $this->sources[$table_name]['FIELD_DEF'][$name];
		} else {
			foreach($this->sources as $table_name => $table) {
				foreach ($table['FIELD_DEF'] as $k => $field) {
					if (($field->name == $name)
						or (
							($field->alias == strtolower($name))
							)
						){
						$fo =& $this->sources[$table_name]['FIELD_DEF'][$k];
						break 2;
					}
				}
			}
			if (!isset($fo)) {
				$this->_error(_G__FIELD_NOT_FOUND, $name);
				return $fo;
			}
		}

		//$fo->ref = true;
		if (!in_array($name, $this->where_fields, true))
			$this->where_fields[] = $name;

		if (!isset($this->allfields[$name]))
			$this->allfields[$name] =& $fo;

		return $fo;
	}

	function _get_hand(&$sql) {
		$hand = $this->conn->_get_hand_imm($sql);
		if ($hand !== false)
			return $hand;
		if (preg_match('/\\s*(\\w+)\\.(\\w+)/A', $sql, $m, PREG_OFFSET_CAPTURE, $this->offset)) {
			$this->offset = $m[2][1]+strlen($m[2][0]);
			$fo =& $this->_get_where_field(strtoupper($m[1][0]), strtoupper($m[2][0]));
			if ($fo === null)
				return false;
			return new field($fo);
		}
		if (preg_match('/\\s*(\\w+)/A', $sql, $m, PREG_OFFSET_CAPTURE, $this->offset)) {
			$this->offset = $m[0][1]+strlen($m[0][0]);
			$field = strtoupper($m[1][0]);
			if ($field === 'NULL') {
				return new value( NULL );
			}
			$fo =& $this->_get_where_field('', $field);
			if ($fo === null)
				return false;
			return new field($fo);
		}
		return false;
	}

	## retrieves hand expression
	function _get_hand_expr(&$expr, $subexpr = false) {

		$hand = $this->_get_hand($expr);
		if ($hand === false)
			return false;

		if ($subexpr) {
			if ($this->_closing_p($expr)) {
				return $hand;
			}
		}

		while (preg_match('/\\s*(\\+|-|\\*|\\/|%)/A', $expr,
						$m, PREG_OFFSET_CAPTURE, $this->offset)) {
			$this->offset = $m[1][1] + 1;
			//TODO: opening_p can happen here
			if (false === ($other_hand = $this->_get_hand($expr))) {
				return false;
			}
			$hand = new arith_expr($hand, $other_hand, $m[1][0]);
		}

		return $hand;
	}

	## parse one expression
	function _parse_one_expr(&$sql) {

		$left = $this->_get_hand_expr($sql);
		if ($left === false) {
			$this->_error(_G__LHAND_EXPECTED);
			return null;
		}

		if (!preg_match('/\\s*(=|<>|<=|>=|>|<)/iA', $sql,
						$m, PREG_OFFSET_CAPTURE, $this->offset)) {

			if (!preg_match('/\\s*(not\\s+)?(like|in|between)/iA', $sql,
				$m, PREG_OFFSET_CAPTURE, $this->offset)) {
					$this->_error(_G__OPERATOR_EXPECTED);
					return null;
			} else {
				$raw_operator = strtolower($m[2][0]);
				$this->offset = $m[2][1]+strlen($m[2][0]);
				$neg = (!empty($m[1][0]));

				switch ($raw_operator) {
					case 'in':
						if (!preg_match('/\\s*\\(\\s*/A', $sql, $m, 0, $this->offset)) {
							$this->_error(_G__EXPECTED_OPP);
							return null;
						}
						$this->offset += strlen($m[0]);
						$values = array();
						if (preg_match('/select\\s+(.)/iA', $sql,
							$m, PREG_OFFSET_CAPTURE, $this->offset)) {
							include_once 'gladius_sqlops.php';
							$this->conn->offset = $m[1][1];
							$old_fm = $this->conn->fetch_mode;
							$this->conn->fetch_mode = GLADIUS_FETCH_NUM;
							$rs = $this->conn->do_select($sql, true);
							$this->conn->fetch_mode = $old_fm;
							if ($rs === false)
								return null;
							if (count($rs->fields)> 1) {
								$this->_error(_G__TOO_MANY_FIELDS);
								return null;
							}
							// terminate the subquery (if not previously terminated)
							if (preg_match('/\\s*\\)\\s*/A', $sql, $m, 0, $this->offset)) {
								$this->offset += strlen($m[0]);
							}

							if ($rvalues = $rs->GetArray()) {
								foreach($rvalues as $row)
									$values[] =& $row[0];
								unset($rvalues);
							}
							unset($rs);
						} else { // parse a simple values list
							while (false !== ($hand = $this->_get_hand_imm($sql))) {
								$values[] = $hand->evaluate();
								if (!preg_match('/\\s*,\\s*/A', $sql, $m, 0, $this->offset))
									break;
								$this->offset += strlen($m[0]);
							}
							if (!preg_match('/\\s*\\)\\s*/A', $sql, $m, 0, $this->offset)) {
								$this->_error(_G__MISS_CLS);
								return null;
							}
							$this->offset += strlen($m[0]);
						}
						if (count($values) == 0) {
							$this->_error(_G__SET_EXPECTED);
							return null;
						}

						if ($neg)
							$raw_operator = 'nin_op';
						else
							$raw_operator = 'in_op';
						return new $raw_operator($left, $values);
					break;
					case 'between':
						$l = $this->_get_hand_expr($sql);
						if ($l === false) {
							$this->_error(_G__LHAND_EXPECTED);
							return null;
						}
						if (!preg_match('/\\s+and\\s+/iA', $sql,
							$m, 0, $this->offset)) {
							$this->_error(_G__AND_EXPECTED);
							return null;
						}
						$this->offset += strlen($m[0]);
						$r = $this->_get_hand_expr($sql);
						if ($r === false) {
							$this->_error(_G__RHAND_EXPECTED);
							return null;
						}
						if ($neg) {
							$a = '<=';
							$b = '>=';
						} else {
							$a = '>=';
							$b = '<=';
						} // convert the BETWEEN to a double comparison
						$bw = new expr ($left, $l, $a);
						$bw->bool_op = 'and';
						$bw->next = new expr ($left, $r, $b);
						return $bw;
				}
			}
		} else {
			$raw_operator = strtolower($m[1][0]);
			$this->offset = $m[1][1]+strlen($m[1][0]);

			$right = $this->_get_hand_expr($sql);
			if ($right === false) {
				$this->_error(_G__RHAND_EXPECTED);
				return null;
			}
		}


//		echo '<b>EXPR</b> (('.get_class($left).')'.$left->content;
//		echo ' '.$raw_operator.' ('.get_class($right).')'.$right->content.')';

		return new expr($left, $right, $raw_operator);
	}

	function _get_boolean_op(&$expr) {

		if (preg_match('/\\s*(\\w+)\\s*/iA', $expr, $m, PREG_OFFSET_CAPTURE, $this->offset)) {
			$boolean = strtolower($m[1][0]);
			$this->offset = $m[1][1]+strlen($m[1][0]);
			return $boolean;
		}
		return false;
	}

	function _parse_order_expr(&$sql) {
		if (!preg_match('/\\s*order\\s+by\\s+/iA',
					$sql, $m, PREG_OFFSET_CAPTURE, $this->offset))
			return true;
		$this->offset = $m[0][1]+strlen($m[0][0]);

		$fields = array_flip(array_keys($this->fields));

		while (preg_match('/\\s*(\\w+)\\s*(ASC|DESC)?\\s*(,)?/iA',
			$sql, $m, PREG_OFFSET_CAPTURE, $this->offset)) {

			$field = strtoupper($m[1][0]);
			for($t=0;$t<$this->tot_t;$t++) {
				$schema =& $this->sources[$this->tables[$t]];
				if (!isset($schema['FIELD_DEF'][$field])) {
					$this->_error(_G__FIELD_NOT_FOUND, $field);
					return false;
				} else {
					$fo =& $this->sources[$this->tables[$t]]['FIELD_DEF'][$field];
					break;
				}
			}

			if (!isset($fields[$fo->name])) {
				$this->order_fields[] = $fo->name;
				$this->order_ids[] = count($fields) + count($this->order_fields) - 2;
			} else
				$this->order_ids[] = $fields[$fo->name];
			$this->allfields[$fo->name] =& $fo;

			$c = count($m);
			$this->offset = $m[$c-1][1]+strlen($m[$c-1][0]);
			if ($c>2) {
				if (strtolower($m[2][0])=='desc')
					$this->order_way[] = SORT_DESC;
				else // ASC already checked by the regular expression
					$this->order_way[] = SORT_ASC;
				if ($c<4)
					break;
				if ($m[3][0] != ',') {
					$this->_error(_G__MALFORMED_SQL);
					return false;
				}

			} else {
				$this->order_way[] = SORT_ASC;
				break;
			}
		}

		return true;
	}

	function _parse_limit(&$sql) {
		if (preg_match('/\\s*limit\\s+(\\d+)\\s*,?\\s*([\\+\\-]?\\d+)?/iA',
			$sql, $m, PREG_OFFSET_CAPTURE, $this->offset)) {

			$c=count($m);
			if ($c==3) {
				$limit_from = (int)$m[1][0];
				if ( 0 >= ($limit_length = (int)$m[2][0]) )
					return false;
			} else {
				$limit_from = 0;
				if (0 >= ($limit_length = (int)$m[1][0]))
					return false;
			}
			$this->offset = $m[$c-1][1]+strlen($m[$c-1][0]);
		} else {
			$limit_from = 0;
			$limit_length = 0;
		}
		return array($limit_from, $limit_length);
	}

	function _add_all_fields($table) {
		foreach (array_keys($this->sources[$table]['FIELD_DEF']) as $field) {
			$fo =& $this->sources[$table]['FIELD_DEF'][$field];
//			$fo->ref = true;
			$this->fields[$fo->name] =& $fo;
			$this->allfields[$fo->name] =& $fo;
			$this->aliases[] = $fo->alias;
		}
	}

	function _load_fields(&$fields,&$aliases) {
		$found_asterisk = false;
		$aliases = array();
		foreach ($fields as $fld) {
			$alias = $fld[1];
			$a = explode('.', $fld[0], 3);
			switch (count($a)) {
				case 1:
					if ($a[0]=='*') {
						if ($found_asterisk) {
							$this->_error(_G__ASTERISK_AGAIN);
							return false;
						}
						$found_asterisk = true;
						foreach($this->tables as $table_name)
							$this->_add_all_fields($table_name);
								continue 2;
					}
					$field = $a[0];
					$table = null;
					for($t=0;$t<$this->tot_t;$t++) {
						$table_name = $this->tables[$t];
						$schema =& $this->sources[$table_name];
						if (isset($schema['FIELD_DEF'][$field])) {
							if (isset($table)) {
								$this->_error(_G__AMBIGUOUS_FIELD, $field);
								return false;
							}
							$table = $table_name;
						}
					}
					if (!isset($table)) {
						$this->_error(_G__FIELD_NOT_FOUND, $field);
						return false;
					}
				break;
				case 2:
					$table = $a[0];
					if (!isset($this->sources[$table])) {
						$this->_error(_G__TABLE_NOT_SELECTED, $table);
						return false;
					}
					if ($a[1]=='*') {
						$this->_add_all_fields($table);
						continue 2;
					}
					$field = $a[1];
					if (isset($this->sources[$table]['FIELD_DEF'][$field])) {
						$this->_error(_G__FIELD_NOT_FOUND, $field);
						return false;
					}
				break;
				default:
					$this->_error(_G__MALFORMED_SQL);
					return false;
			}

			$fo =& $this->sources[$table]['FIELD_DEF'][$field];
//			$fo->ref = true;
			if (!empty($alias)) {
				$alias = strtolower($alias);
				if (in_array($alias, $aliases)) {
					$this->_error(_G__AMBIGUOUS_ALIAS, $alias);
					return false;
				}
				$fo->alias = $alias;
			}
			$aliases[] = $fo->alias;

			$this->fields[$fo->name] =& $fo;
			$this->allfields[$fo->name] =& $fo;
		}
		return true;
	}

	function _remove_order(&$fo, &$ranges) {

		$new_order = array();
		foreach ($fo->ordered as $i) {
			$delta = 0;
			foreach($ranges as $range) {
				if (($i >= $range[0]) && ($i<$range[0]+$range[1]))
					continue 2;
				if ($i < $range[0])
					break;
				$delta += $range[1];
			}
			$new_order[] = $i - $delta;
		}
		$fo->ordered = $new_order;
	}

}
?>
