<?php
## Gladius Database Engine
# @author legolas558
# @version 0.1
# Licensed under GNU General Public License (GPL)
#
#
# SELECT command interpretation
#
	$fields = array();
	while (preg_match('/\\s*([\\w\\.\\*]*)(\\s+(as\\s+)?(\\w+))?\\s*(,)?/iA',
		$sql, $m, PREG_OFFSET_CAPTURE, $this->offset)) {

		$this->offset = $m[count($m)-1][1]+strlen($m[count($m)-1][0]);

		$alias = strtoupper($m[4][0]);
		if (gladius_reserved($alias)) {
			if (!empty($m[3][0])) {
				$this->_error(_G__INVALID_ALIAS, $alias);
				return false;
			}
			// save the last field recognized
			$fields[] = array(strtoupper($m[1][0]), '');
			break;
		}

		// alias unicity will later be checked
		$fields[] = array(strtoupper($m[1][0]), $alias);

		// if no comma was specified break the cycle
		if (!isset($m[5])) {
			if (!preg_match('/\\s*FROM\\s*/iA', $sql, $m, PREG_OFFSET_CAPTURE, $this->offset)) {
				$this->_error(_G__MALFORMED_SQL);
				return false;
			}
			$this->offset= $m[0][1] + strlen($m[0][0]);
			break;
		}

	}
	if (empty($fields)) {
		$this->_error(_G__MALFORMED_SQL);
		return false;
	}

	$from = array();
	if (!$this->_parse_from($sql, $from))
		return false;

	if (false ===($rs = $this->_create_rs($from)))
		return false;

	$rs->in_subquery = $subquery;

	if (!$rs->_load_fields($fields, $rs->aliases))
		return false;

	if (!$rs->_parse_where_expr($sql))
		return false;

	if (!$subquery && !$rs->_parse_order_expr($sql))
		return false;

	$limits = $rs->_parse_limit($sql);
	if ($limits === false) {
		$this->_error(_G__INVALID_LIMIT);
		return false;
	}

	//TODO:check for correct statement termination

	//dicriminate between where columns and other columns
	foreach($rs->allfields as $fo) {
		$this->_hold_column($fo->table, $fo->name);	// cache all fields
		if (!in_array($fo->name, $rs->where_fields))
			$rs->iteration_arg[] = $fo->name;	// index the non-where fields
	}

	$rs->initiate();

	// setup value decoders
	global $GLADIUS_CUSTOM_DATA;
	$fkeys = array_keys($rs->fields);
	$rs->keys = array();
	$i = 0;
	foreach ($fkeys as $key) {
		if (in_array($rs->fields[$key]->type, $GLADIUS_CUSTOM_DATA)) {
			if (($rs->fetch_mode == GLADIUS_FETCH_NUM) || ($rs->fetch_mode == GLADIUS_FETCH_BOTH))
				$rs->keys[$key] = $i++;
			else
				$rs->keys[$key] = $rs->fields[$key]->alias;
		}
	}

	if (!empty($rs->order_way)) {
		include_once('gladius_order.php');

		// iteration argument will contain fields not updated by WHERE evaluation + ordering fields not in the selected list
		$rs->iteration_arg = array_merge($rs->iteration_arg, $rs->order_fields);

		// create a rowset with ordering fields too
		while ($rs->_iterate('_order_fetch')) { }

		if ($rs->row_count==0)
			return $rs;

		// apply ordering
		rowsort($rs);

		$rs->limit_from = $limits[0];
		$rs->limit_length = $limits[1];

		// fix the resultset
		$rs->recompile_rowset();

		unset($rs->order_way);
		unset($rs->order_ids);
	} else {
		$rs->limit_from = $limits[0];
		$rs->limit_length = $limits[1];
	}

	$this->_success($rs->row_count);
	return $rs;
?>
