<?php
## Gladius Database Engine
# @author legolas558
# @version 0.1
# Licensed under GNU General Public License (GPL)
#
#
# UPDATE command interpretation
#
	if (!preg_match('/\\s*(\\w+)\\s+set(\\s)/iA',
					$sql, $m, PREG_OFFSET_CAPTURE, $m[1][1]+6)) {
		$this->_error(_G__MALFORMED_SQL);
		return false;
	}

	$table = strtoupper($m[1][0]);
	$from = array( array($table, '') );
	$this->offset = $m[2][1]+1;

	if (false ===($rs = $this->_create_rs($from)))
		return false;

	$rs->ops = array();
	while (preg_match('/\\s*(\\w+)\\s*=\\s*(.)/iA',
					  $sql, $m, PREG_OFFSET_CAPTURE, $this->offset)) {

		$field = strtoupper($m[1][0]);

		if (!isset($this->schemas[$table]['FIELD_DEF'][$field])) {
			$this->_error(_G__FIELD_NOT_FOUND, $field);
			return false;
		}
		$this->_hold_column($table, $field);

		$this->offset = $m[2][1];

		$rs->ops[$field] = $rs->_get_hand($sql);

		preg_match('/\\s*(,|\\s)/A', $sql, $m, PREG_OFFSET_CAPTURE, $this->offset);

		$this->offset = $m[1][1]+1;
		if ($m[1][0] != ',')
			break;
	}

	if (empty($rs->ops)) {
		$this->_error(_G__MALFORMED_SQL);
		return false;
	}

	if (!$rs->_parse_where_expr($sql))
		return false;

	if (!$rs->_parse_limit($sql)) {
		$this->_error(_G__INVALID_LIMIT);
		return false;
	}

	$rs->initiate();

	foreach($rs->where_fields as $field) {
		$fo =& $rs->allfields[$field];
		$this->_hold_column($fo->table, $fo->name);
	}

	$rs->updated = array();

	while ($rs->_iterate('_update_row')) { }

	if (empty($rs->iteration_arg)) {
		$this->_success(0);
		return true;
	}

	$fields = array_keys($rs->ops);
	foreach ($fields as $field) {
		$column =& $this->pool[$table][$field];
		$delta = 0;

		$fo =& $this->schemas[$table]['FIELD_DEF'][$field];
		if ($fo->indexed)
			$rs->_remove_order($fo, $rs->iteration_arg);

//		echo'<pre>';var_dump($fo->ordered);echo'</pre>';
		foreach ($rs->iteration_arg as $range) {
			array_splice($column, $range[0], $range[1],
						 array_slice($rs->updated[$field], $delta, $range[1])
			);
			$delta += $range[1];
			if ($fo->indexed) {
				for ($i=0;$i<$range[1];$i++) {
					$this->_update_order($fo, $column, $rs->updated[$field][$range[0]+$i]);
				}
			}
		}
		$path = $this->database.$table.'.'.$field.'.php';
		gladius_save($path, $column);

//		echo'<pre>';var_dump($fo->ordered);echo'</pre><hr>';
	}

	gladius_save($this->database.$table.'.php', $this->schemas[$table]);

	$this->_success($delta);
	return true;
?>