<?php
## PHP error tracer
# @author legolas558
#
# gives a debug backtrace for caught errors

function fix_path($path) {
  global $d_root;
  $p = substr($path,0,strlen($d_root)-1);
  if(strpos($path,$p)!==false)
	$path=substr($path,strlen($p)+1);
  return str_replace('\\','/',$path);
}

function Drake_error_handler ($errno, $errstr, $errfile, $errline) {
  $errlevel = error_reporting();
  if (!($errno & $errlevel)) return;
  if (($errno == 8) && ($errlevel>2047))
	return;	// we ignore this type of notices from rev658
  global $old_err_handler;
//  echo '<div style="position:absolute; z-index:0"><img src="images/common/crack.png"></div>';
//  @ob_end_clean();
  echo '</table><div id="errorinfo" style="text-align: left; background-image: url(images/common/crack.png);  background-repeat: no-repeat; background-color:white; border: 3px solid;"><h1>Drake unhandled error</h1>';
  echo '<h2>Please report this error to <a style="font-size:18px"  href="http://sourceforge.net/tracker/?group_id=166901&atid=840802">our bug tracker</a> <u>IF</u> it has not already been reported.'."\n".'We are sorry for the inconvenience; thanks for your collaboration.</h2>';
  echo '<img src="images/common/cut.png"><hr><h3>Version information</h3><big>';
	version_info();
	echo '</big><h3>Debug backtrace</h3><big><pre>';
	$error = '';
	if ($dbg = @debug_backtrace()) {
		$c = count($dbg);
		for ($i=$c-1;$i>1;$i--) {
			$error .= @fix_path($dbg[$i]['file']).'('.@$dbg[$i]['line'].'): '.
					$dbg[$i]['function'].'('.@count($dbg[$i]['args']).')'."\n";
		}
	}
	$error .=	'<div style="font-size:16px; background-color: black; color:cyan">'.
			fix_path($errfile);
	$error .= "($errline): E$errno";
	echo $error;
	echo ' '.$errstr;
	echo'</div></pre></big><hr><img src="images/common/cut.png">';
	// error submission not yet available
	if ($dbg && false) { ?>
	<h3>Error submission</h3>
	<form name="errform" method="GET" action="http://drakecms.sourceforge.net/error.php?ehash=<?php echo md5($error); ?>">
		<input type="hidden" name="drakever" value="<?php global $d_version; echo $d_version; ?>">
		<input type="hidden" name="dbg" value="<?php echo htmlentities($error.' '.$errstr); ?>">
		<input type="hidden" name="phpver" value="<?php echo phpversion(); ?>">
		<input type="hidden" name="dbtype" value="<?php global $d_db; echo $d_db; ?>">
		<input type="hidden" name="server" value="<?php echo @$_SERVER["SERVER_SOFTWARE"] ?>">
		<p>Press the below button to submit the above error information (Drake version, debug backtrace, PHP version number, database type and server version).</p>
		<p>The comment field is optional, add only your sourceforge.net user name if you have one.</p>
		<p>&nbsp;<textarea name="comment" cols="35" rows="3" maxlength="250"></textarea></p>
		<input type="submit">
	</form>
	<?php }
	echo '</div>';
	die;
}

?>