<?php
## common admin/user includes
# @author legolas558
#
# included files for each Drake CMS instance

function mt_float()
{
   list($usec, $sec) = explode(' ', microtime());
   return ((float)$usec + (float)$sec);
}

// { ***** DEBUG *****

$page_start_time = mt_float();

include $d_root.'includes/errtrace.php';

//L: only in debug releases!
set_error_handler('Drake_error_handler');

// ***** DEBUG ***** }

//L: in the beginning, there was no configuration, and the User installed Drake
if (!file_exists( $d_root.$d_private.'config.php' )) {
	header( "Location: install/index.php" );
	exit();
}

include $d_root.$d_private.'config.php';

//L: And the User forgot to rename/remove the install folder
if (is_dir($d_root.'install')) {
//L: but Drake showed itself being offline not to allow mailicous users to re-install
	include $d_root.'includes/servererror.php';
	service_msg('Offline', $d_offline_msg);
	exit();
}

error_reporting( $d_error_level );

@session_start();

$time = time() + $d_offset*60*60;	//L: Q: is it really working? possible bottlenecks?

$includes_dir=$d_root.'includes/';
$components_dir=$d_root.'components/';
$modules_dir=$d_root.'modules/';
$classes_dir=$d_root.'classes/';
$images_dir=$d_root.'images/';

include $d_root.'includes/dracon.php';

$d_type = 'html';	//L: intended as XHTML?

$querycount=0;	//L: this looks like a debug variable, RFC!

$d_cookiepath = getcookiepath();

function getcookiepath() {
	global $d_website;
	$hostlen = strlen($_SERVER['HTTP_HOST']);
	$findpath = substr($d_website,strpos($d_website,$_SERVER['HTTP_HOST'])+$hostlen);
	return ($findpath);
}

include $d_root.'includes/adodb.php';

include $d_root.'classes/user.php';

$my = new User();

$edit_acl = 'editgroup<'.($my->gid+1);
$access_acl = 'access<'.($my->gid+1);
$access_sql='AND '.$access_acl;

include $d_root.'lang/'.$my->lang.'/common.php';

$access_level=array(
	array('name'=>_USERS_GRP_0,'value'=>'0'),
	array('name'=>_USERS_GRP_1,'value'=>'1'),
	array('name'=>_USERS_GRP_2,'value'=>'2'),
	array('name'=>_USERS_GRP_3,'value'=>'3'),
	array('name'=>_USERS_GRP_4,'value'=>'4'),
	array('name'=>_USERS_GRP_5,'value'=>'5')
	);

$d_admin_level[] = '';		// unregistered users have no rights
$d_admin_level[] = '';		// registered users have no admin rights
$d_admin_level[] = ' edit_content ';
$d_admin_level[] = ' admin_login admin_content admin_help '.$d_admin_level[2];
$d_admin_level[] = ' admin_templates admin_language admin_menu admin_components admin_modules '.$d_admin_level[3];

function access_bygid($gid) {
	global $access_level;
	if (empty($gid)) return $access_level[0]['name'];
	foreach($access_level as $acl) {
		if ($acl['value']==$gid)
			return $acl['name'];
	}
	return $gid;
}

include($includes_dir."functions.php");

include($classes_dir."drake.php");

//L: the play begins
$d = new Drake();

//L: we have to optimize (even more) the below visit counter
//L: it should be disabled (at option) from the backend
//L: we should also have a brief statistic through it
include($classes_dir."stats.php");

$stats = new Stats();

include($d_root.'lang/'.$my->lang.'/user.php');

localize($my->lang);

/* ALLOWED GLOBALS SECTION */

$option = in_path('option', $_GET);

$catid = in_num('catid');

$Itemid = in_num('Itemid', $_GET, 0);

?>